// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepBlend_Corde_HeaderFile
#define _BRepBlend_Corde_HeaderFile

#ifndef _Handle_Adaptor3d_HSurface_HeaderFile
#include <Handle_Adaptor3d_HSurface.hxx>
#endif
#ifndef _Handle_Adaptor3d_HCurve_HeaderFile
#include <Handle_Adaptor3d_HCurve.hxx>
#endif
#ifndef _gp_Pnt_HeaderFile
#include <gp_Pnt.hxx>
#endif
#ifndef _gp_Pnt2d_HeaderFile
#include <gp_Pnt2d.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _gp_Vec_HeaderFile
#include <gp_Vec.hxx>
#endif
#ifndef _gp_Vec2d_HeaderFile
#include <gp_Vec2d.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Adaptor3d_HSurface;
class Adaptor3d_HCurve;
class Standard_DomainError;
class BRepBlend_HCurveTool;
class BRepBlend_HSurfaceTool;
class math_Vector;
class math_Matrix;
class gp_Pnt;
class gp_Vec;
class gp_Vec2d;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class BRepBlend_Corde  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT BRepBlend_Corde(const Handle(Adaptor3d_HSurface)& S,const Handle(Adaptor3d_HCurve)& CGuide);


Standard_EXPORT   void SetParam(const Standard_Real Param) ;


Standard_EXPORT   void SetDist(const Standard_Real Dist) ;


Standard_EXPORT   Standard_Boolean Value(const math_Vector& X,math_Vector& F) ;


Standard_EXPORT   Standard_Boolean Derivatives(const math_Vector& X,math_Matrix& D) ;


Standard_EXPORT  const gp_Pnt& PointOnS() const;


Standard_EXPORT  const gp_Pnt& PointOnGuide() const;


Standard_EXPORT  const gp_Vec& NPlan() const;


Standard_EXPORT   Standard_Boolean IsTangencyPoint() const;


Standard_EXPORT  const gp_Vec& TangentOnS() const;


Standard_EXPORT  const gp_Vec2d& Tangent2dOnS() const;


Standard_EXPORT   void DerFguide(const math_Vector& Sol,gp_Vec2d& DerF) ;


Standard_EXPORT   Standard_Boolean IsSolution(const math_Vector& Sol,const Standard_Real Tol) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Adaptor3d_HSurface surf;
Handle_Adaptor3d_HCurve guide;
gp_Pnt pts;
gp_Pnt2d pt2d;
Standard_Real dis;
Standard_Real normtg;
Standard_Real theD;
gp_Pnt ptgui;
gp_Vec nplan;
gp_Vec d1gui;
gp_Vec d2gui;
gp_Vec tgs;
gp_Vec2d tg2d;
Standard_Boolean istangent;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
