// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepLProp_HeaderFile
#define _BRepLProp_HeaderFile

#ifndef _GeomAbs_Shape_HeaderFile
#include <GeomAbs_Shape.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class BRepAdaptor_Curve;
class BRepLProp_CurveTool;
class BRepLProp_SurfaceTool;
class BRepLProp_CLProps;
class BRepLProp_SLProps;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! These global functions compute the degree of <br>
//! continuity of a curve built by concatenation of two <br>
//! edges at their junction point. <br>
class BRepLProp  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT static  GeomAbs_Shape Continuity(const BRepAdaptor_Curve& C1,const BRepAdaptor_Curve& C2,const Standard_Real u1,const Standard_Real u2,const Standard_Real tl,const Standard_Real ta) ;


Standard_EXPORT static  GeomAbs_Shape Continuity(const BRepAdaptor_Curve& C1,const BRepAdaptor_Curve& C2,const Standard_Real u1,const Standard_Real u2) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //

friend class BRepLProp_CurveTool;
friend class BRepLProp_SurfaceTool;
friend class BRepLProp_CLProps;
friend class BRepLProp_SLProps;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
