// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepLib_MakeShape_HeaderFile
#define _BRepLib_MakeShape_HeaderFile

#ifndef _TopoDS_Shape_HeaderFile
#include <TopoDS_Shape.hxx>
#endif
#ifndef _TopTools_ListOfShape_HeaderFile
#include <TopTools_ListOfShape.hxx>
#endif
#ifndef _BRepLib_Command_HeaderFile
#include <BRepLib_Command.hxx>
#endif
#ifndef _BRepLib_ShapeModification_HeaderFile
#include <BRepLib_ShapeModification.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class StdFail_NotDone;
class TopoDS_Shape;
class TopoDS_Face;
class TopTools_ListOfShape;
class TopoDS_Edge;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! This    is  the  root     class for     all  shape <br>
//!          constructions.  It stores the result. <br>
//! <br>
//!          It  provides deferred methods to trace the history <br>
//!          of sub-shapes. <br>
class BRepLib_MakeShape  : public BRepLib_Command {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! This is  called by  Shape().  It does  nothing but <br>
//!          may be redefined. <br>
Standard_EXPORT   void Build() ;


Standard_EXPORT  const TopoDS_Shape& Shape() const;
Standard_EXPORT operator TopoDS_Shape() const;

//! returns the status of the Face after <br>
//!          the shape creation. <br>
Standard_EXPORT virtual  BRepLib_ShapeModification FaceStatus(const TopoDS_Face& F) const;

//! Returns True if the Face generates new topology. <br>
Standard_EXPORT virtual  Standard_Boolean HasDescendants(const TopoDS_Face& F) const;

//! returns the list of generated Faces. <br>
Standard_EXPORT virtual const TopTools_ListOfShape& DescendantFaces(const TopoDS_Face& F) ;

//! returns the number of surfaces <br>
//!          after the shape creation. <br>
Standard_EXPORT virtual  Standard_Integer NbSurfaces() const;

//! Return the faces created for surface I. <br>
Standard_EXPORT virtual const TopTools_ListOfShape& NewFaces(const Standard_Integer I) ;

//! returns a list of the created faces <br>
//!          from the edge <E>. <br>
Standard_EXPORT virtual const TopTools_ListOfShape& FacesFromEdges(const TopoDS_Edge& E) ;





protected:

 // Methods PROTECTED
 // 


Standard_EXPORT BRepLib_MakeShape();


 // Fields PROTECTED
 //
TopoDS_Shape myShape;
TopTools_ListOfShape myGenFaces;
TopTools_ListOfShape myNewFaces;
TopTools_ListOfShape myEdgFaces;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
