// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepMesh_Triangle_HeaderFile
#define _BRepMesh_Triangle_HeaderFile

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _MeshDS_DegreeOfFreedom_HeaderFile
#include <MeshDS_DegreeOfFreedom.hxx>
#endif


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class BRepMesh_Triangle  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT BRepMesh_Triangle();


Standard_EXPORT BRepMesh_Triangle(const Standard_Integer e1,const Standard_Integer e2,const Standard_Integer e3,const Standard_Boolean o1,const Standard_Boolean o2,const Standard_Boolean o3,const MeshDS_DegreeOfFreedom canMove,const Standard_Integer domain = 0);


Standard_EXPORT   void Initialize(const Standard_Integer e1,const Standard_Integer e2,const Standard_Integer e3,const Standard_Boolean o1,const Standard_Boolean o2,const Standard_Boolean o3,const MeshDS_DegreeOfFreedom canMove,const Standard_Integer domain = 0) ;


Standard_EXPORT   void Edges(Standard_Integer& e1,Standard_Integer& e2,Standard_Integer& e3,Standard_Boolean& o1,Standard_Boolean& o2,Standard_Boolean& o3) const;

  MeshDS_DegreeOfFreedom Movability() const;


Standard_EXPORT   void SetMovability(const MeshDS_DegreeOfFreedom Move) ;

  Standard_Integer Domain() const;


Standard_EXPORT   Standard_Integer HashCode(const Standard_Integer Upper) const;


Standard_EXPORT   Standard_Boolean IsEqual(const BRepMesh_Triangle& Other) const;
  Standard_Boolean operator ==(const BRepMesh_Triangle& Other) const
{
  return IsEqual(Other);
}






protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer Edge1;
Standard_Boolean Orientation1;
Standard_Integer Edge2;
Standard_Boolean Orientation2;
Standard_Integer Edge3;
Standard_Boolean Orientation3;
Standard_Integer myDomain;
MeshDS_DegreeOfFreedom myMovability;


};


#include <BRepMesh_Triangle.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//
inline Standard_Integer HashCode(const BRepMesh_Triangle& me,const Standard_Integer Upper) {
 return me.HashCode(Upper);
}



#endif
