// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepPrim_Cylinder_HeaderFile
#define _BRepPrim_Cylinder_HeaderFile

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _BRepPrim_Revolution_HeaderFile
#include <BRepPrim_Revolution.hxx>
#endif
class Standard_DomainError;
class gp_Ax2;
class gp_Pnt;
class TopoDS_Face;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Cylinder primitive. <br>
class BRepPrim_Cylinder  : public BRepPrim_Revolution {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! the STEP definition <br>
//!          Position : center of a Face and Axis <br>
//!          Radius : radius of cylinder <br>
//!          Height : distance between faces <br>
//!                   on positive side <br>
//! <br>
//!          Errors : Height < Resolution <br>
//!                   Radius < Resolution <br>
Standard_EXPORT BRepPrim_Cylinder(const gp_Ax2& Position,const Standard_Real Radius,const Standard_Real Height);

//! infinite Cylinder at origin on Z negative <br>
Standard_EXPORT BRepPrim_Cylinder(const Standard_Real Radius);

//! infinite Cylinder at Center on Z negative <br>
Standard_EXPORT BRepPrim_Cylinder(const gp_Pnt& Center,const Standard_Real Radius);

//! infinite Cylinder at Axes on Z negative <br>
Standard_EXPORT BRepPrim_Cylinder(const gp_Ax2& Axes,const Standard_Real Radius);

//! create a Cylinder  at origin on Z  axis, of <br>
//!          height H and radius R <br>
//!          Error  : Radius  < Resolution <br>
//!                   H < Resolution <br>
//!                   H negative <br>
Standard_EXPORT BRepPrim_Cylinder(const Standard_Real R,const Standard_Real H);

//! same as above but at a given point <br>
Standard_EXPORT BRepPrim_Cylinder(const gp_Pnt& Center,const Standard_Real R,const Standard_Real H);

//! The surface normal should be directed  towards the <br>
//!          outside. <br>
Standard_EXPORT virtual  TopoDS_Face MakeEmptyLateralFace() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT   void SetMeridian() ;


 // Fields PRIVATE
 //
Standard_Real myRadius;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
