// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepTest_HeaderFile
#define _BRepTest_HeaderFile

class Draw_Interpretor;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Provides commands to test BRep. <br>
//! <br>
class BRepTest  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Defines all the topology commands. <br>
Standard_EXPORT static  void AllCommands(Draw_Interpretor& DI) ;

//! Defines the basic commands. <br>
Standard_EXPORT static  void BasicCommands(Draw_Interpretor& DI) ;

//! Defines the commands to build edges and wires. <br>
Standard_EXPORT static  void CurveCommands(Draw_Interpretor& DI) ;

//!  Defines the  commands  to perform add  fillets on <br>
//!          wires and  edges. <br>
Standard_EXPORT static  void Fillet2DCommands(Draw_Interpretor& DI) ;

//! Defines the commands to build faces and shells. <br>
Standard_EXPORT static  void SurfaceCommands(Draw_Interpretor& DI) ;

//! Defines the commands to build primitives. <br>
Standard_EXPORT static  void PrimitiveCommands(Draw_Interpretor& DI) ;

//! Defines the commands to build primitives. <br>
Standard_EXPORT static  void FillingCommands(Draw_Interpretor& DI) ;

//! Defines the commands to sweep shapes. <br>
Standard_EXPORT static  void SweepCommands(Draw_Interpretor& DI) ;

//! Defines  the    commands   to perform  topological <br>
//!          operations. <br>
Standard_EXPORT static  void TopologyCommands(Draw_Interpretor& DI) ;

//! Defines  the commands  to perform  add  fillets on <br>
//!          shells. <br>
Standard_EXPORT static  void FilletCommands(Draw_Interpretor& DI) ;

//! Defines  the commands  to perform  add chamfers on <br>
//!          shells. <br>
Standard_EXPORT static  void ChamferCommands(Draw_Interpretor& DI) ;

//! Defines commands to compute global properties. <br>
Standard_EXPORT static  void GPropCommands(Draw_Interpretor& DI) ;

//! Defines commands to compute and to explore the map of the <br>
//!          Bisecting locus. <br>
Standard_EXPORT static  void MatCommands(Draw_Interpretor& DI) ;

//! Defines the commands to modify draft angles of the <br>
//!          faces of a shape. <br>
Standard_EXPORT static  void DraftAngleCommands(Draw_Interpretor& DI) ;

//! Defines the commands to create features on a shape. <br>
Standard_EXPORT static  void FeatureCommands(Draw_Interpretor& DI) ;

//! Defines the auxiliary topology commands. <br>
Standard_EXPORT static  void OtherCommands(Draw_Interpretor& DI) ;

//! Defines the extrema commands. <br>
Standard_EXPORT static  void ExtremaCommands(Draw_Interpretor& DI) ;

//! Defines the checkshape command. <br>
Standard_EXPORT static  void CheckCommands(Draw_Interpretor& DI) ;

//! Defines the placement  command. <br>
//! <br>
Standard_EXPORT static  void PlacementCommands(Draw_Interpretor& DI) ;

//! Defines the commands to project a wire on a shape. <br>
//! <br>
Standard_EXPORT static  void ProjectionCommands(Draw_Interpretor& DI) ;

//! Defines the commands to prepare shell commands. <br>
Standard_EXPORT static  void ShellCommands(Draw_Interpretor& DI) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
