// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRep_Curve3D_HeaderFile
#define _BRep_Curve3D_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_BRep_Curve3D_HeaderFile
#include <Handle_BRep_Curve3D.hxx>
#endif

#ifndef _Handle_Geom_Curve_HeaderFile
#include <Handle_Geom_Curve.hxx>
#endif
#ifndef _BRep_GCurve_HeaderFile
#include <BRep_GCurve.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_BRep_CurveRepresentation_HeaderFile
#include <Handle_BRep_CurveRepresentation.hxx>
#endif
class Geom_Curve;
class TopLoc_Location;
class gp_Pnt;
class BRep_CurveRepresentation;


//! Representation of a curve by a 3D curve. <br>
class BRep_Curve3D : public BRep_GCurve {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT BRep_Curve3D(const Handle(Geom_Curve)& C,const TopLoc_Location& L);

//! Computes the point at parameter U. <br>
Standard_EXPORT   void D0(const Standard_Real U,gp_Pnt& P) const;

//! Returns True. <br>
Standard_EXPORT virtual  Standard_Boolean IsCurve3D() const;


Standard_EXPORT virtual const Handle_Geom_Curve& Curve3D() const;


Standard_EXPORT virtual  void Curve3D(const Handle(Geom_Curve)& C) ;

//! Return a copy of this representation. <br>
Standard_EXPORT   Handle_BRep_CurveRepresentation Copy() const;
//Standard_EXPORT ~BRep_Curve3D();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Geom_Curve myCurve;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
