// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _CDM_Application_HeaderFile
#define _CDM_Application_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_CDM_Application_HeaderFile
#include <Handle_CDM_Application.hxx>
#endif

#ifndef _Standard_Transient_HeaderFile
#include <Standard_Transient.hxx>
#endif
#ifndef _Handle_CDM_Document_HeaderFile
#include <Handle_CDM_Document.hxx>
#endif
#ifndef _Handle_CDM_MetaData_HeaderFile
#include <Handle_CDM_MetaData.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Resource_Manager_HeaderFile
#include <Handle_Resource_Manager.hxx>
#endif
#ifndef _Handle_CDM_MessageDriver_HeaderFile
#include <Handle_CDM_MessageDriver.hxx>
#endif
#ifndef _Standard_ExtString_HeaderFile
#include <Standard_ExtString.hxx>
#endif
class CDM_Reference;
class CDM_MetaData;
class CDM_Document;
class Resource_Manager;
class CDM_MessageDriver;
class TCollection_ExtendedString;



class CDM_Application : public Standard_Transient {

public:
 // Methods PUBLIC
 // 

//! the manager returned by  this virtual  method will be <br>
//!          used to search for Format`.Retrieval  resource items. <br>
//! <br>
Standard_EXPORT virtual  Handle_Resource_Manager Resources()  = 0;

//! By default returns a NullMessageDriver; <br>
Standard_EXPORT virtual  Handle_CDM_MessageDriver MessageDriver() ;

//! this method is called before the update of a document. <br>
//!         By default, writes in MessageDriver(). <br>
Standard_EXPORT virtual  void BeginOfUpdate(const Handle(CDM_Document)& aDocument) ;

//! this method is called affter the update of a document. <br>
//!         By default, writes in MessageDriver(). <br>
Standard_EXPORT virtual  void EndOfUpdate(const Handle(CDM_Document)& aDocument,const Standard_Boolean Status,const TCollection_ExtendedString& ErrorString) ;

//! writes the string in the application MessagerDriver. <br>
Standard_EXPORT   void Write(const Standard_ExtString aString) ;
//Standard_EXPORT ~CDM_Application();


friend class CDM_Reference;
friend class CDM_MetaData;


 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


Standard_EXPORT   void SetDocumentVersion(const Handle(CDM_Document)& aDocument,const Handle(CDM_MetaData)& aMetaData) const;


Standard_EXPORT   void SetReferenceCounter(const Handle(CDM_Document)& aDocument,const Standard_Integer aReferenceCounter) ;


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT virtual  Handle_CDM_Document Retrieve(const Handle(CDM_MetaData)& aMetaData,const Standard_Boolean UseStorageConfiguration)  = 0;

//! returns -1 if the metadata has no modification counter. <br>
Standard_EXPORT virtual  Standard_Integer DocumentVersion(const Handle(CDM_MetaData)& aMetaData)  = 0;


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
