// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _CPPJini_ClientInfo_HeaderFile
#define _CPPJini_ClientInfo_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_CPPJini_ClientInfo_HeaderFile
#include <Handle_CPPJini_ClientInfo.hxx>
#endif

#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _WOKTools_MapOfHAsciiString_HeaderFile
#include <WOKTools_MapOfHAsciiString.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Transient_HeaderFile
#include <Standard_Transient.hxx>
#endif
#ifndef _Handle_MS_MetaSchema_HeaderFile
#include <Handle_MS_MetaSchema.hxx>
#endif
#ifndef _CPPJini_ExtractionType_HeaderFile
#include <CPPJini_ExtractionType.hxx>
#endif
class TCollection_HAsciiString;
class MS_MetaSchema;


//! stores information about client and its types <br>
class CPPJini_ClientInfo : public Standard_Transient {

public:
 // Methods PUBLIC
 // 

//! constructor <br>
Standard_EXPORT CPPJini_ClientInfo(const Handle(MS_MetaSchema)& aMS,const Handle(TCollection_HAsciiString)& aName,const Standard_Integer aLevel);

//! checks if client has complete type <br>
Standard_EXPORT   Standard_Boolean HasComplete(const Handle(TCollection_HAsciiString)& aName) const;

//! checks if client has incomplete type <br>
Standard_EXPORT   Standard_Boolean HasIncomplete(const Handle(TCollection_HAsciiString)& aName) const;

//! checks if client has semicomplete type <br>
Standard_EXPORT   Standard_Boolean HasSemicomplete(const Handle(TCollection_HAsciiString)& aName) const;

//! checks if client has type defined or not <br>
Standard_EXPORT   Standard_Boolean Defined(const Handle(TCollection_HAsciiString)& aName,CPPJini_ExtractionType& aType) const;

//! returns <myName> field <br>
Standard_EXPORT  const Handle_TCollection_HAsciiString& Name() const;
//! returns level of the client in the 'uses' hierarchy <br>
  Standard_Integer Level() const;
//! returns a flag indicating whether client is a <br>
//!          root in the 'uses' hierarchy <br>
  Standard_Boolean Root() const;
//! sets client state indicating that the client is a root <br>
//!          in the 'uses' hierarchy <br>
  void SetRoot(const Standard_Boolean aRoot) ;
//! sets a level of the client in the 'uses' hierarchy <br>
  void SetLevel(const Standard_Integer aLevel) ;
//Standard_EXPORT ~CPPJini_ClientInfo();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_TCollection_HAsciiString myName;
WOKTools_MapOfHAsciiString myComplete;
WOKTools_MapOfHAsciiString myIncomplete;
WOKTools_MapOfHAsciiString mySemicomplete;
Standard_Integer myLevel;
Standard_Boolean myRoot;


};


#include <CPPJini_ClientInfo.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
