// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Contap_ThePointOfContour_HeaderFile
#define _Contap_ThePointOfContour_HeaderFile

#ifndef _gp_Pnt_HeaderFile
#include <gp_Pnt.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Adaptor2d_HCurve2d_HeaderFile
#include <Handle_Adaptor2d_HCurve2d.hxx>
#endif
#ifndef _IntSurf_Transition_HeaderFile
#include <IntSurf_Transition.hxx>
#endif
#ifndef _Handle_Adaptor3d_HVertex_HeaderFile
#include <Handle_Adaptor3d_HVertex.hxx>
#endif
class Adaptor2d_HCurve2d;
class Adaptor3d_HVertex;
class Standard_DomainError;
class gp_Pnt;
class IntSurf_Transition;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class Contap_ThePointOfContour  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT Contap_ThePointOfContour();


Standard_EXPORT Contap_ThePointOfContour(const gp_Pnt& Pt,const Standard_Real U,const Standard_Real V);

  void SetValue(const gp_Pnt& Pt,const Standard_Real U,const Standard_Real V) ;

  void SetParameter(const Standard_Real Para) ;

  void SetVertex(const Handle(Adaptor3d_HVertex)& V) ;

  void SetArc(const Handle(Adaptor2d_HCurve2d)& A,const Standard_Real Param,const IntSurf_Transition& TLine,const IntSurf_Transition& TArc) ;

  void SetMultiple() ;

  void SetInternal() ;

 const gp_Pnt& Value() const;

  Standard_Real ParameterOnLine() const;

  void Parameters(Standard_Real& U1,Standard_Real& V1) const;

  Standard_Boolean IsOnArc() const;

 const Handle_Adaptor2d_HCurve2d& Arc() const;

  Standard_Real ParameterOnArc() const;

 const IntSurf_Transition& TransitionOnLine() const;

 const IntSurf_Transition& TransitionOnArc() const;

  Standard_Boolean IsVertex() const;

 const Handle_Adaptor3d_HVertex& Vertex() const;

  Standard_Boolean IsMultiple() const;

  Standard_Boolean IsInternal() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
gp_Pnt pt;
Standard_Real uparam;
Standard_Real vparam;
Standard_Real paraline;
Standard_Boolean onarc;
Handle_Adaptor2d_HCurve2d arc;
IntSurf_Transition traline;
IntSurf_Transition traarc;
Standard_Real prmarc;
Standard_Boolean isvtx;
Handle_Adaptor3d_HVertex vtx;
Standard_Boolean ismult;
Standard_Boolean myInternal;


};

#define TheVertex Handle_Adaptor3d_HVertex
#define TheVertex_hxx <Adaptor3d_HVertex.hxx>
#define TheArc Handle_Adaptor2d_HCurve2d
#define TheArc_hxx <Adaptor2d_HCurve2d.hxx>
#define Contap_Point Contap_ThePointOfContour
#define Contap_Point_hxx <Contap_ThePointOfContour.hxx>

#include <Contap_Point.lxx>

#undef TheVertex
#undef TheVertex_hxx
#undef TheArc
#undef TheArc_hxx
#undef Contap_Point
#undef Contap_Point_hxx


// other Inline functions and methods (like "C++: function call" methods)
//


#endif
