// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _DDF_TransactionStack_HeaderFile
#define _DDF_TransactionStack_HeaderFile

#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_DDF_Transaction_HeaderFile
#include <Handle_DDF_Transaction.hxx>
#endif
#ifndef _Handle_DDF_StackNodeOfTransactionStack_HeaderFile
#include <Handle_DDF_StackNodeOfTransactionStack.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Standard_NoSuchObject;
class DDF_StackIteratorOfTransactionStack;
class DDF_Transaction;
class DDF_StackNodeOfTransactionStack;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class DDF_TransactionStack  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT DDF_TransactionStack();


Standard_EXPORT  const DDF_TransactionStack& Assign(const DDF_TransactionStack& Other) ;
 const DDF_TransactionStack& operator =(const DDF_TransactionStack& Other) 
{
  return Assign(Other);
}


  Standard_Boolean IsEmpty() const;

  Standard_Integer Depth() const;


Standard_EXPORT  const Handle_DDF_Transaction& Top() const;


Standard_EXPORT   void Push(const Handle(DDF_Transaction)& I) ;


Standard_EXPORT   void Pop() ;


Standard_EXPORT   void Clear() ;
~DDF_TransactionStack()
{
  Clear();
}



Standard_EXPORT   Handle_DDF_Transaction& ChangeTop() ;


friend class DDF_StackIteratorOfTransactionStack;



protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT DDF_TransactionStack(const DDF_TransactionStack& Other);


 // Fields PRIVATE
 //
Standard_Address myTop;
Standard_Integer myDepth;


};

#define Item Handle_DDF_Transaction
#define Item_hxx <DDF_Transaction.hxx>
#define TCollection_StackNode DDF_StackNodeOfTransactionStack
#define TCollection_StackNode_hxx <DDF_StackNodeOfTransactionStack.hxx>
#define TCollection_StackIterator DDF_StackIteratorOfTransactionStack
#define TCollection_StackIterator_hxx <DDF_StackIteratorOfTransactionStack.hxx>
#define Handle_TCollection_StackNode Handle_DDF_StackNodeOfTransactionStack
#define TCollection_StackNode_Type_() DDF_StackNodeOfTransactionStack_Type_()
#define TCollection_Stack DDF_TransactionStack
#define TCollection_Stack_hxx <DDF_TransactionStack.hxx>

#include <TCollection_Stack.lxx>

#undef Item
#undef Item_hxx
#undef TCollection_StackNode
#undef TCollection_StackNode_hxx
#undef TCollection_StackIterator
#undef TCollection_StackIterator_hxx
#undef Handle_TCollection_StackNode
#undef TCollection_StackNode_Type_
#undef TCollection_Stack
#undef TCollection_Stack_hxx


// other Inline functions and methods (like "C++: function call" methods)
//


#endif
