// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _DrawTrSurf_BSplineCurve_HeaderFile
#define _DrawTrSurf_BSplineCurve_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_DrawTrSurf_BSplineCurve_HeaderFile
#include <Handle_DrawTrSurf_BSplineCurve.hxx>
#endif

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Draw_MarkerShape_HeaderFile
#include <Draw_MarkerShape.hxx>
#endif
#ifndef _Draw_Color_HeaderFile
#include <Draw_Color.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _DrawTrSurf_Curve_HeaderFile
#include <DrawTrSurf_Curve.hxx>
#endif
#ifndef _Handle_Geom_BSplineCurve_HeaderFile
#include <Handle_Geom_BSplineCurve.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Handle_Draw_Drawable3D_HeaderFile
#include <Handle_Draw_Drawable3D.hxx>
#endif
class Geom_BSplineCurve;
class Draw_Color;
class Draw_Display;
class Draw_Drawable3D;



class DrawTrSurf_BSplineCurve : public DrawTrSurf_Curve {

public:
 // Methods PUBLIC
 // 


//!  creates a drawable BSpline curve from a BSpline curve of <br>
//!  package Geom. <br>
Standard_EXPORT DrawTrSurf_BSplineCurve(const Handle(Geom_BSplineCurve)& C);


//!  creates a drawable BSpline curve from a BSpline curve of <br>
//!  package Geom. <br>
Standard_EXPORT DrawTrSurf_BSplineCurve(const Handle(Geom_BSplineCurve)& C,const Draw_Color& CurvColor,const Draw_Color& PolesColor,const Draw_Color& KnotsColor,const Draw_MarkerShape KnotsShape,const Standard_Integer KnotsSize,const Standard_Boolean ShowPoles,const Standard_Boolean ShowKnots,const Standard_Integer Discret,const Standard_Real Deflection,const Standard_Integer DrawMode);


Standard_EXPORT   void DrawOn(Draw_Display& dis) const;


Standard_EXPORT   void DrawOn(Draw_Display& dis,const Standard_Boolean ShowPoles,const Standard_Boolean ShowKnots) const;


Standard_EXPORT   void DrawOn(Draw_Display& dis,const Standard_Real U1,const Standard_Real U2,const Standard_Integer Pindex,const Standard_Boolean ShowPoles = Standard_True,const Standard_Boolean ShowKnots = Standard_True) const;


Standard_EXPORT   void ShowPoles() ;


Standard_EXPORT   void ShowKnots() ;


Standard_EXPORT   void ClearPoles() ;


Standard_EXPORT   void ClearKnots() ;


//!  Returns in <Index> the index of the first pole  of the <br>
//!  curve projected by the Display <D> at a distance lower <br>
//!  than <Prec> from <X,Y>. If no pole  is found  index is <br>
//!  set to 0, else index is always  greater than the input <br>
//!  value of index. <br>
Standard_EXPORT   void FindPole(const Standard_Real X,const Standard_Real Y,const Draw_Display& D,const Standard_Real Prec,Standard_Integer& Index) const;


Standard_EXPORT   void FindKnot(const Standard_Real X,const Standard_Real Y,const Draw_Display& D,const Standard_Real Prec,Standard_Integer& Index) const;

  void SetPolesColor(const Draw_Color& aColor) ;

  void SetKnotsColor(const Draw_Color& aColor) ;

  void SetKnotsShape(const Draw_MarkerShape Shape) ;

  Draw_MarkerShape KnotsShape() const;

  Draw_Color KnotsColor() const;

  Draw_Color PolesColor() const;

//! For variable copy. <br>
Standard_EXPORT virtual  Handle_Draw_Drawable3D Copy() const;
//Standard_EXPORT ~DrawTrSurf_BSplineCurve();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Boolean drawPoles;
Standard_Boolean drawKnots;
Draw_MarkerShape knotsForm;
Draw_Color knotsLook;
Standard_Integer knotsDim;
Draw_Color polesLook;


};


#include <DrawTrSurf_BSplineCurve.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
