// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Dynamic_Parameter_HeaderFile
#define _Dynamic_Parameter_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Dynamic_Parameter_HeaderFile
#include <Handle_Dynamic_Parameter.hxx>
#endif

#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class TCollection_HAsciiString;
class TCollection_AsciiString;


//! A  parameter is defined  as  the association of  a <br>
//!          name and a value.  For easy use, inherited classes <br>
//!          have been  created  to manipulate  values by their <br>
//!          C++ type.  This class is the root class of all the <br>
//!          derived parameter classes.  Only the identifier of <br>
//!          the parameter is  stored  in it.   The  associated <br>
//!          value is stored in the  inherited classes where it <br>
//!          is more  easy to overload the methods manipulating <br>
//!          the  value.   No  instance of  this class  must be <br>
//!          created. It is for this  reason that this class is <br>
//!          deferred. <br>
class Dynamic_Parameter : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! Returns in an AsciiString the name of the parameter. <br>
Standard_EXPORT   TCollection_AsciiString Name() const;

//! Useful for debugging. <br>
Standard_EXPORT virtual  void Dump(Standard_OStream& astream) const;
//Standard_EXPORT ~Dynamic_Parameter();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

//! Initializer of this class  taking in argument the name <br>
//!          of the parameter <aname>. <br>
Standard_EXPORT Dynamic_Parameter(const Standard_CString aname);


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_TCollection_HAsciiString theparametername;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
