// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Dynamic_RealParameter_HeaderFile
#define _Dynamic_RealParameter_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Dynamic_RealParameter_HeaderFile
#include <Handle_Dynamic_RealParameter.hxx>
#endif

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Dynamic_Parameter_HeaderFile
#include <Dynamic_Parameter.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif


//! This  inherited class from Parameter describes all <br>
//!          the parameters, which  are characterized by a real <br>
//!          value. <br>
class Dynamic_RealParameter : public Dynamic_Parameter {

public:
 // Methods PUBLIC
 // 

//! Creates a RealParameter with <aparameter> as name. <br>
Standard_EXPORT Dynamic_RealParameter(const Standard_CString aparameter);

//! With  the name  of the Parameter  <aparameter> and the <br>
//!          real <avalue>, creates an instance of RealParameter. <br>
Standard_EXPORT Dynamic_RealParameter(const Standard_CString aparameter,const Standard_Real avalue);

//! Returns the value of the parameter which is a real. <br>
Standard_EXPORT   Standard_Real Value() const;

//! Sets the real <avalue> in <me>. <br>
Standard_EXPORT   void Value(const Standard_Real avalue) ;

//! Useful for debugging. <br>
Standard_EXPORT virtual  void Dump(Standard_OStream& astream) const;
//Standard_EXPORT ~Dynamic_RealParameter();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Real thevalue;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
