// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Extrema_ExtCC_HeaderFile
#define _Extrema_ExtCC_HeaderFile

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Extrema_SequenceOfPOnCurv_HeaderFile
#include <Extrema_SequenceOfPOnCurv.hxx>
#endif
#ifndef _TColStd_SequenceOfReal_HeaderFile
#include <TColStd_SequenceOfReal.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _gp_Pnt_HeaderFile
#include <gp_Pnt.hxx>
#endif
class StdFail_InfiniteSolutions;
class StdFail_NotDone;
class Standard_OutOfRange;
class Adaptor3d_Curve;
class Extrema_CurveTool;
class Extrema_ECCOfExtCC;
class Extrema_CCFOfECCOfExtCC;
class Extrema_POnCurv;
class gp_Pnt;
class Extrema_ExtElC;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class Extrema_ExtCC  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT Extrema_ExtCC();


Standard_EXPORT Extrema_ExtCC(const Adaptor3d_Curve& C1,const Adaptor3d_Curve& C2,const Standard_Real TolC1 = 1.0e-10,const Standard_Real TolC2 = 1.0e-10);


Standard_EXPORT Extrema_ExtCC(const Adaptor3d_Curve& C1,const Adaptor3d_Curve& C2,const Standard_Real U1,const Standard_Real U2,const Standard_Real V1,const Standard_Real V2,const Standard_Real TolC1 = 1.0e-10,const Standard_Real TolC2 = 1.0e-10);


Standard_EXPORT   void Initialize(const Adaptor3d_Curve& C2,const Standard_Real V1,const Standard_Real V2,const Standard_Real TolC1 = 1.0e-10,const Standard_Real TolC2 = 1.0e-10) ;


Standard_EXPORT   void Perform(const Adaptor3d_Curve& C1,const Standard_Real U1,const Standard_Real U2) ;


Standard_EXPORT   Standard_Boolean IsDone() const;


Standard_EXPORT   Standard_Integer NbExt() const;


Standard_EXPORT   Standard_Boolean IsParallel() const;


Standard_EXPORT   Standard_Real Value(const Standard_Integer N = 1) const;


Standard_EXPORT   void Points(const Standard_Integer N,Extrema_POnCurv& P1,Extrema_POnCurv& P2) const;


Standard_EXPORT   void TrimmedDistances(Standard_Real& dist11,Standard_Real& distP12,Standard_Real& distP21,Standard_Real& distP22,gp_Pnt& P11,gp_Pnt& P12,gp_Pnt& P21,gp_Pnt& P22) const;





protected:

 // Methods PROTECTED
 // 


Standard_EXPORT   void Results(const Extrema_ExtElC& AlgExt,const Standard_Real Ut11,const Standard_Real Ut12,const Standard_Real Ut21,const Standard_Real Ut22) ;


Standard_EXPORT   void Results(const Extrema_ECCOfExtCC& AlgExt,const Standard_Real Ut11,const Standard_Real Ut12,const Standard_Real Ut21,const Standard_Real Ut22) ;


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Boolean myDone;
Standard_Boolean myIsPar;
Extrema_SequenceOfPOnCurv mypoints;
TColStd_SequenceOfReal myValue;
Standard_Integer mynbext;
Standard_Boolean inverse;
Standard_Address myC1;
Standard_Address myC2;
Standard_Real myu1;
Standard_Real myu2;
Standard_Real myv1;
Standard_Real myv2;
Standard_Real mytolc1;
Standard_Real mytolc2;
gp_Pnt P1f;
gp_Pnt P1l;
gp_Pnt P2f;
gp_Pnt P2l;
Standard_Real mydist11;
Standard_Real mydist12;
Standard_Real mydist21;
Standard_Real mydist22;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
