// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Geom2dConvert_CompCurveToBSplineCurve_HeaderFile
#define _Geom2dConvert_CompCurveToBSplineCurve_HeaderFile

#ifndef _Handle_Geom2d_BSplineCurve_HeaderFile
#include <Handle_Geom2d_BSplineCurve.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Convert_ParameterisationType_HeaderFile
#include <Convert_ParameterisationType.hxx>
#endif
#ifndef _Handle_Geom2d_BoundedCurve_HeaderFile
#include <Handle_Geom2d_BoundedCurve.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Geom2d_BSplineCurve;
class Geom2d_BoundedCurve;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Concat sevral curve in an BSplineCurve <br>
class Geom2dConvert_CompCurveToBSplineCurve  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Initialize the algorithme with one curve <br>
//!        - Parameterisation is used to convert <br>
Standard_EXPORT Geom2dConvert_CompCurveToBSplineCurve(const Handle(Geom2d_BoundedCurve)& BasisCurve,const Convert_ParameterisationType Parameterisation = Convert_TgtThetaOver2);

//! Append a curve in the BSpline <br>
//!          Return False if the curve is not G0 with the BSplineCurve. <br>
//!          Tolerance is used to check continuity and decrease <br>
//!          Multiplicty at the common Knot <br>
//!          After is usefull if BasisCurve is a closed curve . <br>
Standard_EXPORT   Standard_Boolean Add(const Handle(Geom2d_BoundedCurve)& NewCurve,const Standard_Real Tolerance,const Standard_Boolean After = Standard_False) ;


Standard_EXPORT   Handle_Geom2d_BSplineCurve BSplineCurve() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

//! Concat two BSplineCurves. <br>
Standard_EXPORT   void Add(Handle(Geom2d_BSplineCurve)& FirstCurve,Handle(Geom2d_BSplineCurve)& SecondCurve,const Standard_Boolean After) ;


 // Fields PRIVATE
 //
Handle_Geom2d_BSplineCurve myCurve;
Standard_Real myTol;
Convert_ParameterisationType myType;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
