// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _GeomFill_Generator_HeaderFile
#define _GeomFill_Generator_HeaderFile

#ifndef _Handle_Geom_Surface_HeaderFile
#include <Handle_Geom_Surface.hxx>
#endif
#ifndef _GeomFill_Profiler_HeaderFile
#include <GeomFill_Profiler.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class Geom_Surface;
class StdFail_NotDone;
class Standard_DomainError;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Create a surface using generating lines.  Inherits <br>
//!          profiler.  The  surface will be  a  BSplineSurface <br>
//!          passing  by   all  the  curves  described  in  the <br>
//!          generator. The VDegree of the resulting surface is <br>
//!          1. <br>
class GeomFill_Generator  : public GeomFill_Profiler {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT GeomFill_Generator();

//! Converts all curves to BSplineCurves. <br>
//!          Set them to the common profile. <br>
//!          Compute the surface (degv = 1). <br>
//!          <PTol> is used to compare 2 knots. <br>
Standard_EXPORT virtual  void Perform(const Standard_Real PTol) ;

 const Handle_Geom_Surface& Surface() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Geom_Surface mySurface;


};


#include <GeomFill_Generator.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
