// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Geom_Point_HeaderFile
#define _Geom_Point_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Geom_Point_HeaderFile
#include <Handle_Geom_Point.hxx>
#endif

#ifndef _Geom_Geometry_HeaderFile
#include <Geom_Geometry.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class gp_Pnt;


//! The abstract class Point describes the common <br>
//! behavior of geometric points in 3D space. <br>
//! The Geom package also provides the concrete class <br>
//! Geom_CartesianPoint. <br>
class Geom_Point : public Geom_Geometry {

public:
 // Methods PUBLIC
 // 

//! returns the Coordinates of <me>. <br>
Standard_EXPORT virtual  void Coord(Standard_Real& X,Standard_Real& Y,Standard_Real& Z) const = 0;

//! returns a non transient copy of <me> <br>
Standard_EXPORT virtual  gp_Pnt Pnt() const = 0;

//! returns the X coordinate of <me>. <br>
Standard_EXPORT virtual  Standard_Real X() const = 0;

//! returns  the Y coordinate of <me>. <br>
Standard_EXPORT virtual  Standard_Real Y() const = 0;

//! returns the Z coordinate of <me>. <br>
Standard_EXPORT virtual  Standard_Real Z() const = 0;

//! Computes the distance between <me> and <Other>. <br>
Standard_EXPORT   Standard_Real Distance(const Handle(Geom_Point)& Other) const;

//! Computes the square distance between <me> and <Other>. <br>
Standard_EXPORT   Standard_Real SquareDistance(const Handle(Geom_Point)& Other) const;
//Standard_EXPORT ~Geom_Point();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
