// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Graphic2d_Polyline_HeaderFile
#define _Graphic2d_Polyline_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Graphic2d_Polyline_HeaderFile
#include <Handle_Graphic2d_Polyline.hxx>
#endif

#ifndef _TShort_Array1OfShortReal_HeaderFile
#include <TShort_Array1OfShortReal.hxx>
#endif
#ifndef _Graphic2d_Line_HeaderFile
#include <Graphic2d_Line.hxx>
#endif
#ifndef _Handle_Graphic2d_GraphicObject_HeaderFile
#include <Handle_Graphic2d_GraphicObject.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Quantity_Length_HeaderFile
#include <Quantity_Length.hxx>
#endif
#ifndef _Handle_Graphic2d_Drawer_HeaderFile
#include <Handle_Graphic2d_Drawer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_ShortReal_HeaderFile
#include <Standard_ShortReal.hxx>
#endif
#ifndef _Aspect_FStream_HeaderFile
#include <Aspect_FStream.hxx>
#endif
#ifndef _Aspect_IFStream_HeaderFile
#include <Aspect_IFStream.hxx>
#endif
class Graphic2d_PolylineDefinitionError;
class Standard_OutOfRange;
class Graphic2d_GraphicObject;
class Graphic2d_Array1OfVertex;
class TColStd_Array1OfReal;
class Graphic2d_Drawer;


//! The primitive Polyline <br>
class Graphic2d_Polyline : public Graphic2d_Line {

public:
 // Methods PUBLIC
 // 

//! Creates a polyline. <br>
//!  Warning: Raises an error if the length of the polyline <br>
//!	    is less than 2 points. <br>
Standard_EXPORT Graphic2d_Polyline(const Handle(Graphic2d_GraphicObject)& aGraphicObject,const Graphic2d_Array1OfVertex& aListVertex);

//! Creates a polyline. <br>
//!  Warning: Raises an error if the length of the polyline <br>
//!	    is less than 2 points or if length of <aListX> <br>
//!	    is not equal to length of <aListY>. <br>
Standard_EXPORT Graphic2d_Polyline(const Handle(Graphic2d_GraphicObject)& aGraphicObject,const TColStd_Array1OfReal& aListX,const TColStd_Array1OfReal& aListY);

//! Returns the number of points of the line. <br>
Standard_EXPORT   Standard_Integer Length() const;

//! Returns the point of rank <aRank> from the line. <br>
Standard_EXPORT   void Values(const Standard_Integer aRank,Quantity_Length& X,Quantity_Length& Y) const;


Standard_EXPORT virtual  void Save(Aspect_FStream& aFStream) const;


Standard_EXPORT static  void Retrieve(Aspect_IFStream& anIFStream,const Handle(Graphic2d_GraphicObject)& aGraphicObject) ;
//Standard_EXPORT ~Graphic2d_Polyline();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

//! Draws the polyline <me>. <br>
Standard_EXPORT   void Draw(const Handle(Graphic2d_Drawer)& aDrawer) ;

//! Draws edge <anIndex> of the polyline <me>. <br>
Standard_EXPORT virtual  void DrawElement(const Handle(Graphic2d_Drawer)& aDrawer,const Standard_Integer anIndex) ;

//! Draws vertex <anIndex> of the polyline <me>. <br>
Standard_EXPORT virtual  void DrawVertex(const Handle(Graphic2d_Drawer)& aDrawer,const Standard_Integer anIndex) ;

//! Returns Standard_True if the polyline <me> is picked, <br>
//!	    Standard_False if not. <br>
//!  Warning: The method PickIndex() returns the last picked point <br>
//!	    rank of the line or 0 if picking occurs inside <br>
//!	    the filled line. <br>
Standard_EXPORT   Standard_Boolean Pick(const Standard_ShortReal X,const Standard_ShortReal Y,const Standard_ShortReal aPrecision,const Handle(Graphic2d_Drawer)& aDrawer) ;


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TShort_Array1OfShortReal myX;
TShort_Array1OfShortReal myY;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
