// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _HatchGen_Domains_HeaderFile
#define _HatchGen_Domains_HeaderFile

#ifndef _TCollection_BaseSequence_HeaderFile
#include <TCollection_BaseSequence.hxx>
#endif
#ifndef _Handle_HatchGen_SequenceNodeOfDomains_HeaderFile
#include <Handle_HatchGen_SequenceNodeOfDomains.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class Standard_NoSuchObject;
class Standard_OutOfRange;
class HatchGen_Domain;
class HatchGen_SequenceNodeOfDomains;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class HatchGen_Domains  : public TCollection_BaseSequence {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

HatchGen_Domains();


Standard_EXPORT   void Clear() ;
~HatchGen_Domains()
{
  Clear();
}



Standard_EXPORT  const HatchGen_Domains& Assign(const HatchGen_Domains& Other) ;
 const HatchGen_Domains& operator =(const HatchGen_Domains& Other) 
{
  return Assign(Other);
}



Standard_EXPORT   void Append(const HatchGen_Domain& T) ;

  void Append(HatchGen_Domains& S) ;


Standard_EXPORT   void Prepend(const HatchGen_Domain& T) ;

  void Prepend(HatchGen_Domains& S) ;

  void InsertBefore(const Standard_Integer Index,const HatchGen_Domain& T) ;

  void InsertBefore(const Standard_Integer Index,HatchGen_Domains& S) ;


Standard_EXPORT   void InsertAfter(const Standard_Integer Index,const HatchGen_Domain& T) ;

  void InsertAfter(const Standard_Integer Index,HatchGen_Domains& S) ;


Standard_EXPORT  const HatchGen_Domain& First() const;


Standard_EXPORT  const HatchGen_Domain& Last() const;

  void Split(const Standard_Integer Index,HatchGen_Domains& Sub) ;


Standard_EXPORT  const HatchGen_Domain& Value(const Standard_Integer Index) const;
 const HatchGen_Domain& operator()(const Standard_Integer Index) const
{
  return Value(Index);
}



Standard_EXPORT   void SetValue(const Standard_Integer Index,const HatchGen_Domain& I) ;


Standard_EXPORT   HatchGen_Domain& ChangeValue(const Standard_Integer Index) ;
  HatchGen_Domain& operator()(const Standard_Integer Index) 
{
  return ChangeValue(Index);
}



Standard_EXPORT   void Remove(const Standard_Integer Index) ;


Standard_EXPORT   void Remove(const Standard_Integer FromIndex,const Standard_Integer ToIndex) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT HatchGen_Domains(const HatchGen_Domains& Other);


 // Fields PRIVATE
 //


};

#define SeqItem HatchGen_Domain
#define SeqItem_hxx <HatchGen_Domain.hxx>
#define TCollection_SequenceNode HatchGen_SequenceNodeOfDomains
#define TCollection_SequenceNode_hxx <HatchGen_SequenceNodeOfDomains.hxx>
#define Handle_TCollection_SequenceNode Handle_HatchGen_SequenceNodeOfDomains
#define TCollection_SequenceNode_Type_() HatchGen_SequenceNodeOfDomains_Type_()
#define TCollection_Sequence HatchGen_Domains
#define TCollection_Sequence_hxx <HatchGen_Domains.hxx>

#include <TCollection_Sequence.lxx>

#undef SeqItem
#undef SeqItem_hxx
#undef TCollection_SequenceNode
#undef TCollection_SequenceNode_hxx
#undef Handle_TCollection_SequenceNode
#undef TCollection_SequenceNode_Type_
#undef TCollection_Sequence
#undef TCollection_Sequence_hxx


// other Inline functions and methods (like "C++: function call" methods)
//


#endif
