// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESAppli_PWBDrilledHole_HeaderFile
#define _IGESAppli_PWBDrilledHole_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESAppli_PWBDrilledHole_HeaderFile
#include <Handle_IGESAppli_PWBDrilledHole.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif


//! defines PWBDrilledHole, Type <406> Form <26> <br>
//!          in package IGESAppli <br>
//!          Used to identify an entity that locates a drilled hole <br>
//!          and to specify the characteristics of the drilled hole <br>
class IGESAppli_PWBDrilledHole : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESAppli_PWBDrilledHole();

//! This method is used to set the fields of the class <br>
//!           PWBDrilledHole <br>
//!       - nbPropVal  : number of property values, always = 3 <br>
//!       - aDrillDia  : Drill diameter size <br>
//!       - aFinishDia : Finish diameter size <br>
//!       - aCode      : Function code for drilled hole <br>
Standard_EXPORT   void Init(const Standard_Integer nbPropVal,const Standard_Real aDrillDia,const Standard_Real aFinishDia,const Standard_Integer aCode) ;

//! returns number of property values, always = 3 <br>
Standard_EXPORT   Standard_Integer NbPropertyValues() const;

//! returns Drill diameter size <br>
Standard_EXPORT   Standard_Real DrillDiameterSize() const;

//! returns Finish diameter size <br>
Standard_EXPORT   Standard_Real FinishDiameterSize() const;

//! returns Function code for drilled hole <br>
//! is 0, 1, 2, 3, 4, 5 or 5001-9999 <br>
Standard_EXPORT   Standard_Integer FunctionCode() const;
//Standard_EXPORT ~IGESAppli_PWBDrilledHole();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer theNbPropertyValues;
Standard_Real theDrillDiameter;
Standard_Real theFinishDiameter;
Standard_Integer theFunctionCode;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
