// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESAppli_PinNumber_HeaderFile
#define _IGESAppli_PinNumber_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESAppli_PinNumber_HeaderFile
#include <Handle_IGESAppli_PinNumber.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
class TCollection_HAsciiString;


//! defines PinNumber, Type <406> Form <8> <br>
//!          in package IGESAppli <br>
//!          Used to attach a text string representing a component <br>
//!          pin number to an entity being used to represent an <br>
//!          electrical component's pin <br>
class IGESAppli_PinNumber : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESAppli_PinNumber();

//! This method is used to set the fields of the class <br>
//!           PinNumber <br>
//!       - nbPropVal : Number of property values (always = 1) <br>
//!       - aValue    : Pin Number value <br>
Standard_EXPORT   void Init(const Standard_Integer nbPropVal,const Handle(TCollection_HAsciiString)& aValue) ;

//! returns the number of property values <br>
//! is always 1 <br>
Standard_EXPORT   Standard_Integer NbPropertyValues() const;

//! returns the pin number value <br>
Standard_EXPORT   Handle_TCollection_HAsciiString PinNumberVal() const;
//Standard_EXPORT ~IGESAppli_PinNumber();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer theNbPropertyValues;
Handle_TCollection_HAsciiString thePinNumber;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
