// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESBasic_Hierarchy_HeaderFile
#define _IGESBasic_Hierarchy_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESBasic_Hierarchy_HeaderFile
#include <Handle_IGESBasic_Hierarchy.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif


//! defines Hierarchy, Type <406> Form <10> <br>
//!          in package IGESBasic <br>
//!          Provides ability to control the hierarchy of each <br>
//!          directory entry attribute. <br>
class IGESBasic_Hierarchy : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESBasic_Hierarchy();

//! This method is used to set the fields of the class <br>
//!           Hierarchy <br>
//!       - nbPropVal     : Number of Property values = 6 <br>
//!       - aLineFont     : indicates the line font <br>
//!       - aView         : indicates the view <br>
//!       - aEntityLevel  : indicates the entity level <br>
//!       - aBlankStatus  : indicates the blank status <br>
//!       - aLineWt       : indicates the line weight <br>
//!       - aColorNum     : indicates the color num <br>
//! aLineFont, aView, aEntityLevel, aBlankStatus, aLineWt and <br>
//! aColorNum can take 0 or 1. <br>
//! 0 : The directory entry attribute will apply to entities <br>
//! physically subordinate to this entity. <br>
//! 1 : The directory entry attribute of this entity will not <br>
//! apply to physically subordinate entities. <br>
Standard_EXPORT   void Init(const Standard_Integer nbPropVal,const Standard_Integer aLineFont,const Standard_Integer aView,const Standard_Integer anEntityLevel,const Standard_Integer aBlankStatus,const Standard_Integer aLineWt,const Standard_Integer aColorNum) ;

//! returns the number of property values, which should be 6 <br>
Standard_EXPORT   Standard_Integer NbPropertyValues() const;

//! returns the line font <br>
Standard_EXPORT   Standard_Integer NewLineFont() const;

//! returns the view <br>
Standard_EXPORT   Standard_Integer NewView() const;

//! returns the entity level <br>
Standard_EXPORT   Standard_Integer NewEntityLevel() const;

//! returns the blank status <br>
Standard_EXPORT   Standard_Integer NewBlankStatus() const;

//! returns the line weight <br>
Standard_EXPORT   Standard_Integer NewLineWeight() const;

//! returns the color number <br>
Standard_EXPORT   Standard_Integer NewColorNum() const;
//Standard_EXPORT ~IGESBasic_Hierarchy();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer theNbPropertyValues;
Standard_Integer theLineFont;
Standard_Integer theView;
Standard_Integer theEntityLevel;
Standard_Integer theBlankStatus;
Standard_Integer theLineWeight;
Standard_Integer theColorNum;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
