// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESGeom_ToolFlash_HeaderFile
#define _IGESGeom_ToolFlash_HeaderFile

#ifndef _Handle_IGESGeom_Flash_HeaderFile
#include <Handle_IGESGeom_Flash.hxx>
#endif
#ifndef _Handle_IGESData_IGESReaderData_HeaderFile
#include <Handle_IGESData_IGESReaderData.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Interface_Check_HeaderFile
#include <Handle_Interface_Check.hxx>
#endif
#ifndef _Handle_Message_Messenger_HeaderFile
#include <Handle_Message_Messenger.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class Standard_DomainError;
class IGESGeom_Flash;
class IGESData_IGESReaderData;
class IGESData_ParamReader;
class IGESData_IGESWriter;
class Interface_EntityIterator;
class IGESData_DirChecker;
class Interface_ShareTool;
class Interface_Check;
class Interface_CopyTool;
class IGESData_IGESDumper;
class Message_Messenger;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Tool to work on a Flash. Called by various Modules <br>
//!           (ReadWriteModule, GeneralModule, SpecificModule) <br>
class IGESGeom_ToolFlash  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Returns a ToolFlash, ready to work <br>
Standard_EXPORT IGESGeom_ToolFlash();

//! Reads own parameters from file. <PR> gives access to them, <br>
//!           <IR> detains parameter types and values <br>
Standard_EXPORT   void ReadOwnParams(const Handle(IGESGeom_Flash)& ent,const Handle(IGESData_IGESReaderData)& IR,IGESData_ParamReader& PR) const;

//! Writes own parameters to IGESWriter <br>
Standard_EXPORT   void WriteOwnParams(const Handle(IGESGeom_Flash)& ent,IGESData_IGESWriter& IW) const;

//! Lists the Entities shared by a Flash <ent>, from <br>
//!           its specific (own) parameters <br>
Standard_EXPORT   void OwnShared(const Handle(IGESGeom_Flash)& ent,Interface_EntityIterator& iter) const;

//! Sets automatic unambiguous Correction on a Flash <br>
//!           (LineFont in Directory Entry forced to Rank = 1) <br>
Standard_EXPORT   Standard_Boolean OwnCorrect(const Handle(IGESGeom_Flash)& ent) const;

//! Returns specific DirChecker <br>
Standard_EXPORT   IGESData_DirChecker DirChecker(const Handle(IGESGeom_Flash)& ent) const;

//! Performs Specific Semantic Check <br>
Standard_EXPORT   void OwnCheck(const Handle(IGESGeom_Flash)& ent,const Interface_ShareTool& shares,Handle(Interface_Check)& ach) const;

//! Copies Specific Parameters <br>
Standard_EXPORT   void OwnCopy(const Handle(IGESGeom_Flash)& entfrom,const Handle(IGESGeom_Flash)& entto,Interface_CopyTool& TC) const;

//! Dump of Specific Parameters <br>
Standard_EXPORT   void OwnDump(const Handle(IGESGeom_Flash)& ent,const IGESData_IGESDumper& dumper,const Handle(Message_Messenger)& S,const Standard_Integer own) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
