// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESGraph_LineFontDefTemplate_HeaderFile
#define _IGESGraph_LineFontDefTemplate_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESGraph_LineFontDefTemplate_HeaderFile
#include <Handle_IGESGraph_LineFontDefTemplate.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_IGESBasic_SubfigureDef_HeaderFile
#include <Handle_IGESBasic_SubfigureDef.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _IGESData_LineFontEntity_HeaderFile
#include <IGESData_LineFontEntity.hxx>
#endif
class IGESBasic_SubfigureDef;


//! defines IGESLineFontDefTemplate, Type <304> Form <1> <br>
//!           in package IGESGraph <br>
class IGESGraph_LineFontDefTemplate : public IGESData_LineFontEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESGraph_LineFontDefTemplate();

//! This method is used to set the fields of the class <br>
//!           LineFontDefTemplate <br>
//!       - anOrientation : Orientation of Template figure on <br>
//!                         anchoring curve <br>
//!       - aTemplate     : SubfigureDef entity used as Template figure <br>
//!       - aDistance     : Distance between the neighbouring Template <br>
//!                         figures <br>
//!       - aScale        : Scale factor applied to the Template figure <br>
Standard_EXPORT   void Init(const Standard_Integer anOrientation,const Handle(IGESBasic_SubfigureDef)& aTemplate,const Standard_Real aDistance,const Standard_Real aScale) ;

//! if return value = 0, Each Template display is oriented by aligning <br>
//!                      the axis of the SubfigureDef with the axis of <br>
//!                      the definition space of the anchoring curve. <br>
//!                 = 1, Each Template display is oriented by aligning <br>
//!                      X-axis of the SubfigureDef with the tangent <br>
//!                      vector of the anchoring curve at the point of <br>
//!                      incidence of the curve and the origin of <br>
//!                      subfigure. <br>
//!                      Similarly Z-axis is aligned. <br>
Standard_EXPORT   Standard_Integer Orientation() const;

//! returns SubfigureDef as the Entity used as Template figure. <br>
Standard_EXPORT   Handle_IGESBasic_SubfigureDef TemplateEntity() const;

//! returns the Distance between any two Template figures on the <br>
//! anchoring curve. <br>
Standard_EXPORT   Standard_Real Distance() const;

//! returns the Scaling factor applied to SubfigureDef to form <br>
//! Template figure. <br>
Standard_EXPORT   Standard_Real Scale() const;
//Standard_EXPORT ~IGESGraph_LineFontDefTemplate();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer theOrientation;
Handle_IGESBasic_SubfigureDef theTemplateEntity;
Standard_Real theDistance;
Standard_Real theScale;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
