// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESSelect_ComputeStatus_HeaderFile
#define _IGESSelect_ComputeStatus_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESSelect_ComputeStatus_HeaderFile
#include <Handle_IGESSelect_ComputeStatus.hxx>
#endif

#ifndef _IGESSelect_ModelModifier_HeaderFile
#include <IGESSelect_ModelModifier.hxx>
#endif
#ifndef _Handle_IGESData_IGESModel_HeaderFile
#include <Handle_IGESData_IGESModel.hxx>
#endif
class IFSelect_ContextModif;
class IGESData_IGESModel;
class Interface_CopyTool;
class TCollection_AsciiString;


//! Computes Status of IGES Entities for a whole IGESModel. <br>
//!           This concerns SubordinateStatus and UseFlag, which must have <br>
//!           some definite values according the way they are referenced. <br>
//!           (see definitions of Logical use, Physical use, etc...) <br>
//! <br>
//!           Works by calling a BasicEditor from IGESData. Works on the <br>
//!           whole produced (target) model, because computation is global. <br>
class IGESSelect_ComputeStatus : public IGESSelect_ModelModifier {

public:
 // Methods PUBLIC
 // 

//! Creates an ComputeStatus, which uses the system Date <br>
Standard_EXPORT IGESSelect_ComputeStatus();

//! Specific action : it first evaluates the required values for <br>
//!           Subordinate Status and Use Flag (in Directory Part of each <br>
//!           IGES Entity). Then it corrects them, for the whole target. <br>
//!           Works with a Protocol. Implementation uses BasicEditor <br>
Standard_EXPORT   void Performing(IFSelect_ContextModif& ctx,const Handle(IGESData_IGESModel)& target,Interface_CopyTool& TC) const;

//! Returns a text which is <br>
//!           "Compute Subordinate Status and Use Flag" <br>
Standard_EXPORT   TCollection_AsciiString Label() const;
//Standard_EXPORT ~IGESSelect_ComputeStatus();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
