// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESSelect_SelectPCurves_HeaderFile
#define _IGESSelect_SelectPCurves_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESSelect_SelectPCurves_HeaderFile
#include <Handle_IGESSelect_SelectPCurves.hxx>
#endif

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _IFSelect_SelectExplore_HeaderFile
#include <IFSelect_SelectExplore.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
class Standard_Transient;
class Interface_Graph;
class Interface_EntityIterator;
class TCollection_AsciiString;


//! This Selection returns the pcurves which lie on a face <br>
//!           In two modes : global (i.e. a CompositeCurve is not explored) <br>
//!           or basic (all the basic curves are listed) <br>
class IGESSelect_SelectPCurves : public IFSelect_SelectExplore {

public:
 // Methods PUBLIC
 // 

//! Creates a SelectPCurves <br>
//!           basic True  : lists all the components of pcurves <br>
//!           basic False : lists the uppest level definitions <br>
//!             (i.e. stops at CompositeCurve) <br>
Standard_EXPORT IGESSelect_SelectPCurves(const Standard_Boolean basic);

//! Explores an entity, to take its contained PCurves <br>
//!           An independant curve is IGNORED : only faces are explored <br>
Standard_EXPORT   Standard_Boolean Explore(const Standard_Integer level,const Handle(Standard_Transient)& ent,const Interface_Graph& G,Interface_EntityIterator& explored) const;

//! Returns a text defining the criterium : "Basic PCurves" or <br>
//!           "Global PCurves" <br>
Standard_EXPORT   TCollection_AsciiString ExploreLabel() const;
//Standard_EXPORT ~IGESSelect_SelectPCurves();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Boolean thebasic;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
