// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESSelect_SignColor_HeaderFile
#define _IGESSelect_SignColor_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESSelect_SignColor_HeaderFile
#include <Handle_IGESSelect_SignColor.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _IFSelect_Signature_HeaderFile
#include <IFSelect_Signature.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Handle_Interface_InterfaceModel_HeaderFile
#include <Handle_Interface_InterfaceModel.hxx>
#endif
class Standard_Transient;
class Interface_InterfaceModel;


//! Gives Color attached to an entity <br>
//!           Several forms are possible, according to <mode> <br>
//!           1 : number : "Dnn" for entity, "Snn" for standard, "(none)" for 0 <br>
//!           2 : name : Of standard color, or of the color entity, or "(none)" <br>
//!               (if the color entity has no name, its label is taken) <br>
//!           3 : RGB values, form R:nn,G:nn,B:nn <br>
//!           4 : RED value   : an integer <br>
//!           5 : GREEN value : an integer <br>
//!           6 : BLUE value  : an integer <br>
//!           Other computable values can be added if needed : <br>
//!           CMY values, Percentages for Hue, Lightness, Saturation <br>
class IGESSelect_SignColor : public IFSelect_Signature {

public:
 // Methods PUBLIC
 // 

//! Creates a SignColor <br>
//!           mode : see above for the meaning <br>
//!           modes 4,5,6 give a numeric integer value <br>
//!           Name is initialised according to the mode <br>
Standard_EXPORT IGESSelect_SignColor(const Standard_Integer mode);

//! Returns the value (see above) <br>
Standard_EXPORT   Standard_CString Value(const Handle(Standard_Transient)& ent,const Handle(Interface_InterfaceModel)& model) const;
//Standard_EXPORT ~IGESSelect_SignColor();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer themode;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
