// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESSelect_SignStatus_HeaderFile
#define _IGESSelect_SignStatus_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESSelect_SignStatus_HeaderFile
#include <Handle_IGESSelect_SignStatus.hxx>
#endif

#ifndef _IFSelect_Signature_HeaderFile
#include <IFSelect_Signature.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Handle_Interface_InterfaceModel_HeaderFile
#include <Handle_Interface_InterfaceModel.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Standard_Transient;
class Interface_InterfaceModel;
class TCollection_AsciiString;


//! Gives D.E. Status under the form i,j,k,l (4 figures) <br>
//!           i for BlankStatus <br>
//!           j for SubordinateStatus <br>
//!           k for UseFlag <br>
//!           l for Hierarchy <br>
//! <br>
//!           For matching, allowed shortcuts <br>
//!           B(Blanked) or V(Visible) are allowed instead of  i <br>
//!           I(Independant=0), P(Physically Dep.=1), L(Logically Dep.=2) or <br>
//!             D(Dependant=3) are allowed instead of  j <br>
//!           These letters must be given in their good position <br>
//!           For non-exact matching : <br>
//!           a letter (see above), no comma : only this status is checked <br>
//!           nothing or a star between commas : this status is OK <br>
class IGESSelect_SignStatus : public IFSelect_Signature {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESSelect_SignStatus();

//! Returns the value (see above) <br>
Standard_EXPORT   Standard_CString Value(const Handle(Standard_Transient)& ent,const Handle(Interface_InterfaceModel)& model) const;

//! Performs the match rule (see above) <br>
Standard_EXPORT virtual  Standard_Boolean Matches(const Handle(Standard_Transient)& ent,const Handle(Interface_InterfaceModel)& model,const TCollection_AsciiString& text,const Standard_Boolean exact) const;
//Standard_EXPORT ~IGESSelect_SignStatus();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
