// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESSelect_UpdateLastChange_HeaderFile
#define _IGESSelect_UpdateLastChange_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESSelect_UpdateLastChange_HeaderFile
#include <Handle_IGESSelect_UpdateLastChange.hxx>
#endif

#ifndef _IGESSelect_ModelModifier_HeaderFile
#include <IGESSelect_ModelModifier.hxx>
#endif
#ifndef _Handle_IGESData_IGESModel_HeaderFile
#include <Handle_IGESData_IGESModel.hxx>
#endif
class IFSelect_ContextModif;
class IGESData_IGESModel;
class Interface_CopyTool;
class TCollection_AsciiString;


//! Allows to Change the Last Change Date indication in the Header <br>
//!           (Global Section) of IGES File. It is taken from the operating <br>
//!           system (time of application of the Modifier). <br>
//!           The Selection of the Modifier is not used : it simply acts as <br>
//!           a criterium to select IGES Files to touch up. <br>
//!           Remark : IGES Models noted as version before IGES 5.1 are in <br>
//!           addition changed to 5.1 <br>
class IGESSelect_UpdateLastChange : public IGESSelect_ModelModifier {

public:
 // Methods PUBLIC
 // 

//! Creates an UpdateLastChange, which uses the system Date <br>
Standard_EXPORT IGESSelect_UpdateLastChange();

//! Specific action : only <target> is used : the system Date <br>
//!           is set to Global Section Item n0 25. Also sets IGES Version <br>
//!           (Item n0 23) to IGES5 if it was older. <br>
Standard_EXPORT   void Performing(IFSelect_ContextModif& ctx,const Handle(IGESData_IGESModel)& target,Interface_CopyTool& TC) const;

//! Returns a text which is <br>
//!           "Update IGES Header Last Change Date" <br>
Standard_EXPORT   TCollection_AsciiString Label() const;
//Standard_EXPORT ~IGESSelect_UpdateLastChange();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
