// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESSolid_Face_HeaderFile
#define _IGESSolid_Face_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESSolid_Face_HeaderFile
#include <Handle_IGESSolid_Face.hxx>
#endif

#ifndef _Handle_IGESData_IGESEntity_HeaderFile
#include <Handle_IGESData_IGESEntity.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_IGESSolid_HArray1OfLoop_HeaderFile
#include <Handle_IGESSolid_HArray1OfLoop.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_IGESSolid_Loop_HeaderFile
#include <Handle_IGESSolid_Loop.hxx>
#endif
class IGESData_IGESEntity;
class IGESSolid_HArray1OfLoop;
class Standard_OutOfRange;
class IGESSolid_Loop;


//! defines Face, Type <510> Form Number <1> <br>
//!          in package IGESSolid <br>
//!          Face entity is a bound (partial) which has finite area <br>
class IGESSolid_Face : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESSolid_Face();

//! This method is used to set the fields of the class Face <br>
//!       - aSurface      : Pointer to the underlying surface <br>
//!       - outerLoopFlag : True means the first loop is the outer loop <br>
//!       - loops         : Array of loops bounding the face <br>
Standard_EXPORT   void Init(const Handle(IGESData_IGESEntity)& aSurface,const Standard_Boolean outerLoopFlag,const Handle(IGESSolid_HArray1OfLoop)& loops) ;

//! returns the underlying surface of the face <br>
Standard_EXPORT   Handle_IGESData_IGESEntity Surface() const;

//! returns the number of the loops bounding the face <br>
Standard_EXPORT   Standard_Integer NbLoops() const;

//! checks whether there is an outer loop or not <br>
Standard_EXPORT   Standard_Boolean HasOuterLoop() const;

//! returns the Index'th loop that bounds the face <br>
//! raises exception if Index < 0 or Index >= NbLoops <br>
Standard_EXPORT   Handle_IGESSolid_Loop Loop(const Standard_Integer Index) const;
//Standard_EXPORT ~IGESSolid_Face();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_IGESData_IGESEntity theSurface;
Standard_Boolean hasOuterLoop;
Handle_IGESSolid_HArray1OfLoop theLoops;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
