// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _ImageUtility_X11Dump_HeaderFile
#define _ImageUtility_X11Dump_HeaderFile

#ifndef _ImageUtility_X11Display_HeaderFile
#include <ImageUtility_X11Display.hxx>
#endif
#ifndef _ImageUtility_X11Window_HeaderFile
#include <ImageUtility_X11Window.hxx>
#endif
#ifndef _ImageUtility_X11XImage_HeaderFile
#include <ImageUtility_X11XImage.hxx>
#endif
#ifndef _ImageUtility_X11GC_HeaderFile
#include <ImageUtility_X11GC.hxx>
#endif
#ifndef _Handle_Image_Image_HeaderFile
#include <Handle_Image_Image.hxx>
#endif
class Image_Image;
class Standard_TypeMismatch;
class TCollection_AsciiString;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class ImageUtility_X11Dump  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Create a new X11 Display,Window,Colormap,GC,XImage suitable <br>
//!		for aImage . <br>
Standard_EXPORT ImageUtility_X11Dump(const TCollection_AsciiString& DisplayName,const Handle(Image_Image)& aImage);

//! Create a new X11 XImage and share Display,Window,Colormap, <br>
//!	     GC with a previous aX11Dump ; <br>
Standard_EXPORT ImageUtility_X11Dump(const ImageUtility_X11Dump& aX11Dump,const Handle(Image_Image)& aImage);


Standard_EXPORT   ImageUtility_X11GC X11GC() const;


Standard_EXPORT   ImageUtility_X11Window X11Window() const;


Standard_EXPORT   ImageUtility_X11Display X11Display() const;


Standard_EXPORT   ImageUtility_X11XImage X11XImage() const;


Standard_EXPORT   void UpdateX11Colormap() const;


Standard_EXPORT   void UpdateX11XImage() ;


Standard_EXPORT   void DisplayX11XImage() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
ImageUtility_X11Display myDisplay;
ImageUtility_X11Window myWindow;
ImageUtility_X11XImage myXImage;
ImageUtility_X11GC myGC;
Handle_Image_Image myImage;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
