// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IntPatch_ThePointOfIntersection_HeaderFile
#define _IntPatch_ThePointOfIntersection_HeaderFile

#ifndef _IntSurf_PntOn2S_HeaderFile
#include <IntSurf_PntOn2S.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Adaptor3d_HVertex_HeaderFile
#include <Handle_Adaptor3d_HVertex.hxx>
#endif
#ifndef _Handle_Adaptor2d_HCurve2d_HeaderFile
#include <Handle_Adaptor2d_HCurve2d.hxx>
#endif
#ifndef _IntSurf_Transition_HeaderFile
#include <IntSurf_Transition.hxx>
#endif
class Adaptor3d_HVertex;
class Adaptor2d_HCurve2d;
class Standard_DomainError;
class gp_Pnt;
class IntSurf_Transition;
class IntSurf_PntOn2S;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class IntPatch_ThePointOfIntersection  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT IntPatch_ThePointOfIntersection();


Standard_EXPORT   void SetValue(const gp_Pnt& Pt,const Standard_Real Tol,const Standard_Boolean Tangent) ;


Standard_EXPORT   void SetValue(const gp_Pnt& Pt) ;


Standard_EXPORT   void SetTolerance(const Standard_Real Tol) ;


Standard_EXPORT   void SetParameters(const Standard_Real U1,const Standard_Real V1,const Standard_Real U2,const Standard_Real V2) ;


Standard_EXPORT   void SetParameter(const Standard_Real Para) ;


Standard_EXPORT   void SetVertex(const Standard_Boolean OnFirst,const Handle(Adaptor3d_HVertex)& V) ;


Standard_EXPORT   void SetArc(const Standard_Boolean OnFirst,const Handle(Adaptor2d_HCurve2d)& A,const Standard_Real Param,const IntSurf_Transition& TLine,const IntSurf_Transition& TArc) ;


Standard_EXPORT   void SetMultiple(const Standard_Boolean IsMult) ;

 const gp_Pnt& Value() const;

  Standard_Real ParameterOnLine() const;

  Standard_Real Tolerance() const;

  Standard_Boolean IsTangencyPoint() const;

  void ParametersOnS1(Standard_Real& U1,Standard_Real& V1) const;

  void ParametersOnS2(Standard_Real& U2,Standard_Real& V2) const;

  Standard_Boolean IsMultiple() const;

  Standard_Boolean IsOnDomS1() const;

  Standard_Boolean IsVertexOnS1() const;

 const Handle_Adaptor3d_HVertex& VertexOnS1() const;

 const Handle_Adaptor2d_HCurve2d& ArcOnS1() const;

 const IntSurf_Transition& TransitionLineArc1() const;

 const IntSurf_Transition& TransitionOnS1() const;

  Standard_Real ParameterOnArc1() const;

  Standard_Boolean IsOnDomS2() const;

  Standard_Boolean IsVertexOnS2() const;

 const Handle_Adaptor3d_HVertex& VertexOnS2() const;

 const Handle_Adaptor2d_HCurve2d& ArcOnS2() const;

 const IntSurf_Transition& TransitionLineArc2() const;

 const IntSurf_Transition& TransitionOnS2() const;

  Standard_Real ParameterOnArc2() const;

 const IntSurf_PntOn2S& PntOn2S() const;

  void Parameters(Standard_Real& U1,Standard_Real& V1,Standard_Real& U2,Standard_Real& V2) const;


Standard_EXPORT   void ReverseTransition() ;


Standard_EXPORT   void Dump() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
IntSurf_PntOn2S pt;
Standard_Real para;
Standard_Real tol;
Standard_Boolean tgt;
Standard_Boolean mult;
Standard_Boolean onS1;
Standard_Boolean vtxonS1;
Handle_Adaptor3d_HVertex vS1;
Handle_Adaptor2d_HCurve2d arcS1;
IntSurf_Transition traline1;
IntSurf_Transition tra1;
Standard_Real prm1;
Standard_Boolean onS2;
Standard_Boolean vtxonS2;
Handle_Adaptor3d_HVertex vS2;
Handle_Adaptor2d_HCurve2d arcS2;
IntSurf_Transition traline2;
IntSurf_Transition tra2;
Standard_Real prm2;


};

#define TheVertex Handle_Adaptor3d_HVertex
#define TheVertex_hxx <Adaptor3d_HVertex.hxx>
#define TheArc Handle_Adaptor2d_HCurve2d
#define TheArc_hxx <Adaptor2d_HCurve2d.hxx>
#define IntPatch_Point IntPatch_ThePointOfIntersection
#define IntPatch_Point_hxx <IntPatch_ThePointOfIntersection.hxx>

#include <IntPatch_Point.lxx>

#undef TheVertex
#undef TheVertex_hxx
#undef TheArc
#undef TheArc_hxx
#undef IntPatch_Point
#undef IntPatch_Point_hxx


// other Inline functions and methods (like "C++: function call" methods)
//


#endif
