// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Interface_CopyControl_HeaderFile
#define _Interface_CopyControl_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Interface_CopyControl_HeaderFile
#include <Handle_Interface_CopyControl.hxx>
#endif

#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Interface_InterfaceError;
class Standard_Transient;


//! This deferred class describes the services required by <br>
//!           CopyTool to work. They are very simple and correspond <br>
//!           basically to the management of an indexed map. <br>
//!           But they can be provided by various classes which can <br>
//!           control a Transfer. Each Starting Entity have at most <br>
//!           one Result (Mapping one-one) <br>
class Interface_CopyControl : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! Clears List of Copy Results. Gets Ready to begin another Copy <br>
//!           Process. <br>
Standard_EXPORT virtual  void Clear()  = 0;

//! Bind a Result to a Starting Entity identified by its Number <br>
Standard_EXPORT virtual  void Bind(const Handle(Standard_Transient)& ent,const Handle(Standard_Transient)& res)  = 0;

//! Searches for the Result bound to a Startingf Entity identified <br>
//!           by its Number. <br>
//!           If Found, returns True and fills <res> <br>
//!           Else, returns False and nullifies <res> <br>
Standard_EXPORT virtual  Standard_Boolean Search(const Handle(Standard_Transient)& ent,Handle(Standard_Transient)& res) const = 0;
//Standard_EXPORT ~Interface_CopyControl();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
