// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _LocOpe_HeaderFile
#define _LocOpe_HeaderFile

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class TopoDS_Wire;
class TopoDS_Face;
class TopoDS_Edge;
class TopoDS_Shape;
class TColgp_SequenceOfPnt;
class LocOpe_Builder;
class LocOpe_SplitShape;
class LocOpe_ProjectedWires;
class LocOpe_WiresOnShape;
class LocOpe_Spliter;
class LocOpe_Generator;
class LocOpe_GeneratedShape;
class LocOpe_GluedShape;
class LocOpe_Prism;
class LocOpe_Revol;
class LocOpe_Pipe;
class LocOpe_DPrism;
class LocOpe_LinearForm;
class LocOpe_RevolutionForm;
class LocOpe_Gluer;
class LocOpe_FindEdges;
class LocOpe_FindEdgesInFace;
class LocOpe_DataMapOfShapePnt;
class LocOpe_PntFace;
class LocOpe_CurveShapeIntersector;
class LocOpe_CSIntersector;
class LocOpe_BuildShape;
class LocOpe_SplitDrafts;
class LocOpe_SequenceOfPntFace;
class LocOpe_SequenceOfLin;
class LocOpe_SequenceOfCirc;
class LocOpe_HBuilder;
class LocOpe_BuildWires;
class LocOpe_DataMapNodeOfDataMapOfShapePnt;
class LocOpe_DataMapIteratorOfDataMapOfShapePnt;
class LocOpe_SequenceNodeOfSequenceOfPntFace;
class LocOpe_SequenceNodeOfSequenceOfLin;
class LocOpe_SequenceNodeOfSequenceOfCirc;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Provides  tools to implement local     topological <br>
//!          operations on a shape. <br>
class LocOpe  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT static  Standard_Boolean Closed(const TopoDS_Wire& W,const TopoDS_Face& OnF) ;


Standard_EXPORT static  Standard_Boolean Closed(const TopoDS_Edge& E,const TopoDS_Face& OnF) ;


Standard_EXPORT static  Standard_Boolean TgtFaces(const TopoDS_Edge& E,const TopoDS_Face& F1,const TopoDS_Face& F2) ;


Standard_EXPORT static  void SampleEdges(const TopoDS_Shape& S,TColgp_SequenceOfPnt& Pt) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //

friend class LocOpe_Builder;
friend class LocOpe_SplitShape;
friend class LocOpe_ProjectedWires;
friend class LocOpe_WiresOnShape;
friend class LocOpe_Spliter;
friend class LocOpe_Generator;
friend class LocOpe_GeneratedShape;
friend class LocOpe_GluedShape;
friend class LocOpe_Prism;
friend class LocOpe_Revol;
friend class LocOpe_Pipe;
friend class LocOpe_DPrism;
friend class LocOpe_LinearForm;
friend class LocOpe_RevolutionForm;
friend class LocOpe_Gluer;
friend class LocOpe_FindEdges;
friend class LocOpe_FindEdgesInFace;
friend class LocOpe_DataMapOfShapePnt;
friend class LocOpe_PntFace;
friend class LocOpe_CurveShapeIntersector;
friend class LocOpe_CSIntersector;
friend class LocOpe_BuildShape;
friend class LocOpe_SplitDrafts;
friend class LocOpe_SequenceOfPntFace;
friend class LocOpe_SequenceOfLin;
friend class LocOpe_SequenceOfCirc;
friend class LocOpe_HBuilder;
friend class LocOpe_BuildWires;
friend class LocOpe_DataMapNodeOfDataMapOfShapePnt;
friend class LocOpe_DataMapIteratorOfDataMapOfShapePnt;
friend class LocOpe_SequenceNodeOfSequenceOfPntFace;
friend class LocOpe_SequenceNodeOfSequenceOfLin;
friend class LocOpe_SequenceNodeOfSequenceOfCirc;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
