// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _LocOpe_Generator_HeaderFile
#define _LocOpe_Generator_HeaderFile

#ifndef _TopoDS_Shape_HeaderFile
#include <TopoDS_Shape.hxx>
#endif
#ifndef _Handle_LocOpe_GeneratedShape_HeaderFile
#include <Handle_LocOpe_GeneratedShape.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _TopTools_DataMapOfShapeListOfShape_HeaderFile
#include <TopTools_DataMapOfShapeListOfShape.hxx>
#endif
class LocOpe_GeneratedShape;
class StdFail_NotDone;
class Standard_NullObject;
class Standard_NoSuchObject;
class TopoDS_Shape;
class TopTools_ListOfShape;
class TopoDS_Face;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class LocOpe_Generator  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 
//! Empty constructor. <br>
LocOpe_Generator();
//! Creates the algorithm on the shape <S>. <br>
LocOpe_Generator(const TopoDS_Shape& S);
//! Initializes the algorithm on the shape <S>. <br>
  void Init(const TopoDS_Shape& S) ;


Standard_EXPORT   void Perform(const Handle(LocOpe_GeneratedShape)& G) ;

  Standard_Boolean IsDone() const;
//! Returns the new shape <br>
 const TopoDS_Shape& ResultingShape() const;
//! Returns the initial shape <br>
 const TopoDS_Shape& Shape() const;

//! Returns  the  descendant  face  of <F>.    <F> may <br>
//!          belong to the original shape or to the "generated" <br>
//!          shape.  The returned    face may be   a null shape <br>
//!          (when <F> disappears). <br>
Standard_EXPORT  const TopTools_ListOfShape& DescendantFace(const TopoDS_Face& F) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TopoDS_Shape myShape;
Handle_LocOpe_GeneratedShape myGen;
Standard_Boolean myDone;
TopoDS_Shape myRes;
TopTools_DataMapOfShapeListOfShape myModShapes;


};


#include <LocOpe_Generator.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
