// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _LocOpe_Prism_HeaderFile
#define _LocOpe_Prism_HeaderFile

#ifndef _TopoDS_Shape_HeaderFile
#include <TopoDS_Shape.hxx>
#endif
#ifndef _gp_Vec_HeaderFile
#include <gp_Vec.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _TopTools_DataMapOfShapeListOfShape_HeaderFile
#include <TopTools_DataMapOfShapeListOfShape.hxx>
#endif
#ifndef _Handle_Geom_Curve_HeaderFile
#include <Handle_Geom_Curve.hxx>
#endif
class Standard_NoSuchObject;
class StdFail_NotDone;
class TopoDS_Shape;
class gp_Vec;
class TopTools_ListOfShape;
class TColGeom_SequenceOfCurve;
class Geom_Curve;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Defines a prism (using Prism from BRepSweep) <br>
//!          with modifications provided for the Prism feature. <br>
class LocOpe_Prism  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT LocOpe_Prism();


Standard_EXPORT LocOpe_Prism(const TopoDS_Shape& Base,const gp_Vec& V);


Standard_EXPORT LocOpe_Prism(const TopoDS_Shape& Base,const gp_Vec& V,const gp_Vec& Vectra);


Standard_EXPORT   void Perform(const TopoDS_Shape& Base,const gp_Vec& V) ;


Standard_EXPORT   void Perform(const TopoDS_Shape& Base,const gp_Vec& V,const gp_Vec& Vtra) ;


Standard_EXPORT  const TopoDS_Shape& FirstShape() const;


Standard_EXPORT  const TopoDS_Shape& LastShape() const;


Standard_EXPORT  const TopoDS_Shape& Shape() const;


Standard_EXPORT  const TopTools_ListOfShape& Shapes(const TopoDS_Shape& S) const;


Standard_EXPORT   void Curves(TColGeom_SequenceOfCurve& SCurves) const;


Standard_EXPORT   Handle_Geom_Curve BarycCurve() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT   void IntPerf() ;


 // Fields PRIVATE
 //
TopoDS_Shape myBase;
gp_Vec myVec;
gp_Vec myTra;
Standard_Boolean myIsTrans;
Standard_Boolean myDone;
TopoDS_Shape myRes;
TopoDS_Shape myFirstShape;
TopoDS_Shape myLastShape;
TopTools_DataMapOfShapeListOfShape myMap;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
