// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _MAT_Node_HeaderFile
#define _MAT_Node_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_MAT_Node_HeaderFile
#include <Handle_MAT_Node.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Handle_MAT_Arc_HeaderFile
#include <Handle_MAT_Arc.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class MAT_Arc;
class MAT_SequenceOfArc;
class MAT_SequenceOfBasicElt;



class MAT_Node : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT MAT_Node(const Standard_Integer GeomIndex,const Handle(MAT_Arc)& LinkedArc,const Standard_Real Distance);

//! Returns the index associated of the geometric <br>
//!            representation of <me>. <br>
Standard_EXPORT   Standard_Integer GeomIndex() const;

//! Returns the index associated of the node <br>
Standard_EXPORT   Standard_Integer Index() const;

//! Returns in <S> the Arcs linked to <me>. <br>
Standard_EXPORT   void LinkedArcs(MAT_SequenceOfArc& S) const;

//! Returns  in <S> the BasicElts equidistant <br>
//!          to <me>. <br>
Standard_EXPORT   void NearElts(MAT_SequenceOfBasicElt& S) const;


Standard_EXPORT   Standard_Real Distance() const;

//!Returns True if <me> is a pending Node. <br>
//!          (ie : the number of Arc Linked = 1) <br>
Standard_EXPORT   Standard_Boolean PendingNode() const;

//! Returns True if <me> belongs to the figure. <br>
Standard_EXPORT   Standard_Boolean OnBasicElt() const;

//! Returns True if the distance of <me> is Infinite <br>
Standard_EXPORT   Standard_Boolean Infinite() const;

//! Set the index associated of the node <br>
Standard_EXPORT   void SetIndex(const Standard_Integer anIndex) ;


Standard_EXPORT   void SetLinkedArc(const Handle(MAT_Arc)& anArc) ;
//Standard_EXPORT ~MAT_Node();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer nodeIndex;
Standard_Integer geomIndex;
Standard_Address aLinkedArc;
Standard_Real distance;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
