// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _MDocStd_HeaderFile
#define _MDocStd_HeaderFile

#ifndef _Handle_MDF_ASDriverHSequence_HeaderFile
#include <Handle_MDF_ASDriverHSequence.hxx>
#endif
#ifndef _Handle_CDM_MessageDriver_HeaderFile
#include <Handle_CDM_MessageDriver.hxx>
#endif
#ifndef _Handle_MDF_ARDriverHSequence_HeaderFile
#include <Handle_MDF_ARDriverHSequence.hxx>
#endif
#ifndef _Handle_TDF_Data_HeaderFile
#include <Handle_TDF_Data.hxx>
#endif
#ifndef _Handle_MDF_SRelocationTable_HeaderFile
#include <Handle_MDF_SRelocationTable.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
class MDF_ASDriverHSequence;
class CDM_MessageDriver;
class MDF_ARDriverHSequence;
class TDF_Data;
class MDF_SRelocationTable;
class MDocStd_DocEntryList;
class Standard_Transient;
class Standard_GUID;
class MDocStd_DocumentStorageDriver;
class MDocStd_DocumentRetrievalDriver;
class MDocStd_XLinkStorageDriver;
class MDocStd_XLinkRetrievalDriver;
class MDocStd_PersistentMap;
class MDocStd_DocEntryList;
class MDocStd_StdMapNodeOfPersistentMap;
class MDocStd_MapIteratorOfPersistentMap;
class MDocStd_ListNodeOfDocEntryList;
class MDocStd_ListIteratorOfDocEntryList;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Drivers for TDocStd_Document <br>
class MDocStd  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Adds the attribute storage driver(s) to <aDriverSeq>. <br>
Standard_EXPORT static  void AddStorageDrivers(const Handle(MDF_ASDriverHSequence)& aDriverSeq,const Handle(CDM_MessageDriver)& theMessageDriver) ;

//! Adds the attribute retrieval driver(s) to <aDriverSeq>. <br>
Standard_EXPORT static  void AddRetrievalDrivers(const Handle(MDF_ARDriverHSequence)& aDriverSeq,const Handle(CDM_MessageDriver)& theMessageDriver) ;

//! suppresses the geometries  of the shapes from the XLink <br>
//!          associated to  <aEntry> <br>//! Factory method <br>
//!          ============== <br>
Standard_EXPORT static  void WeightWatcher(const Handle(TDF_Data)& aSource,const Handle(MDF_SRelocationTable)& aReloc,const MDocStd_DocEntryList& aEntry) ;


Standard_EXPORT static  Handle_Standard_Transient Factory(const Standard_GUID& aGUID) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //

friend class MDocStd_DocumentStorageDriver;
friend class MDocStd_DocumentRetrievalDriver;
friend class MDocStd_XLinkStorageDriver;
friend class MDocStd_XLinkRetrievalDriver;
friend class MDocStd_PersistentMap;
friend class MDocStd_DocEntryList;
friend class MDocStd_StdMapNodeOfPersistentMap;
friend class MDocStd_MapIteratorOfPersistentMap;
friend class MDocStd_ListNodeOfDocEntryList;
friend class MDocStd_ListIteratorOfDocEntryList;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
