// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _MPrsStd_HeaderFile
#define _MPrsStd_HeaderFile

#ifndef _Handle_MDF_ASDriverHSequence_HeaderFile
#include <Handle_MDF_ASDriverHSequence.hxx>
#endif
#ifndef _Handle_CDM_MessageDriver_HeaderFile
#include <Handle_CDM_MessageDriver.hxx>
#endif
#ifndef _Handle_MDF_ARDriverHSequence_HeaderFile
#include <Handle_MDF_ARDriverHSequence.hxx>
#endif
class MDF_ASDriverHSequence;
class CDM_MessageDriver;
class MDF_ARDriverHSequence;
class MPrsStd_AISPresentationStorageDriver;
class MPrsStd_PositionStorageDriver;
class MPrsStd_AISPresentationRetrievalDriver;
class MPrsStd_AISPresentationRetrievalDriver_1;
class MPrsStd_PositionRetrievalDriver;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Storage    and  Retrieval  drivers   for graphic <br>
//!          attributes.   Transient  attributes are defined in <br>
//!          package TPrsStd and persistent one are defined in <br>
//!          package PPrsStd <br>
class MPrsStd  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Adds the attribute storage drivers to <aDriverTable>. <br>
Standard_EXPORT static  void AddStorageDrivers(const Handle(MDF_ASDriverHSequence)& aDriverTable,const Handle(CDM_MessageDriver)& theMessageDriver) ;

//! Adds the attribute retrieval drivers to <aDriverTable>. <br>
Standard_EXPORT static  void AddRetrievalDrivers(const Handle(MDF_ARDriverHSequence)& aDriverTable,const Handle(CDM_MessageDriver)& theMessageDriver) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //

friend class MPrsStd_AISPresentationStorageDriver;
friend class MPrsStd_PositionStorageDriver;
friend class MPrsStd_AISPresentationRetrievalDriver;
friend class MPrsStd_AISPresentationRetrievalDriver_1;
friend class MPrsStd_PositionRetrievalDriver;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
