// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _MeshAlgo_CircleTool_HeaderFile
#define _MeshAlgo_CircleTool_HeaderFile

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _MeshDS_BaseAllocator_HeaderFile
#include <MeshDS_BaseAllocator.hxx>
#endif
#ifndef _MeshAlgo_CellFilter_HeaderFile
#include <MeshAlgo_CellFilter.hxx>
#endif
#ifndef _MeshAlgo_CircleInspector_HeaderFile
#include <MeshAlgo_CircleInspector.hxx>
#endif
#ifndef _gp_XY_HeaderFile
#include <gp_XY.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class gp_XY;
class gp_Circ2d;
class TColStd_ListOfInteger;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Create sort   and  destroy the  circles    used in <br>
//!          triangulation. <br>
class MeshAlgo_CircleTool  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT MeshAlgo_CircleTool(const MeshDS_BaseAllocator& theAlloc);

//! Constructs a CircleTool with the maximal dimension <br>
//!          of  the occuped  space and  an  evaluation of  the <br>
//!          number of circles. <br>
Standard_EXPORT MeshAlgo_CircleTool(const Standard_Integer numberOfComponents,const MeshDS_BaseAllocator& theAlloc);

//! Constructs a CircleTool with the maximal dimension <br>
//!          of  the occuped  space and  an  evaluation of  the <br>
//!          number of circles. <br>
Standard_EXPORT   void Initialize(const Standard_Integer numberOfComponents) ;

//! Sets new size for cellfilter <br>
Standard_EXPORT   void SetCellSize(const Standard_Real theSize) ;

//! Sets new size for cellfilter <br>
Standard_EXPORT   void SetCellSize(const Standard_Real theXSize,const Standard_Real theYSize) ;

//! Sets min and max size for circle <br>
Standard_EXPORT   void SetMinMaxSize(const gp_XY& theMin,const gp_XY& theMax) ;

//! Adds and binds circle to the tool. <br>
Standard_EXPORT   void Add(const gp_Circ2d& theCirc,const Standard_Integer theIndex) ;

//! Computes adds and binds circle to the tool. <br>
Standard_EXPORT   Standard_Boolean Add(const gp_XY& p1,const gp_XY& p2,const gp_XY& p3,const Standard_Integer theIndex) ;

//! Adds implicit zero circle <br>
Standard_EXPORT   void MocAdd(const Standard_Integer theIndex) ;

//! Deletes a circle from the tool. <br>
Standard_EXPORT   void Delete(const Standard_Integer theIndex) ;

//! Select the circles which contains thePnt. <br>
Standard_EXPORT   TColStd_ListOfInteger& Select(const gp_XY& thePnt) ;


Standard_EXPORT static  Standard_Integer& GetNbPoints() ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Real Tolerance;
MeshDS_BaseAllocator Allocator;
MeshAlgo_CellFilter CellFilter;
MeshAlgo_CircleInspector Selector;
gp_XY FaceMax;
gp_XY FaceMin;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
