// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _MeshTest_DrawableMesh_HeaderFile
#define _MeshTest_DrawableMesh_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_MeshTest_DrawableMesh_HeaderFile
#include <Handle_MeshTest_DrawableMesh.hxx>
#endif

#ifndef _Handle_BRepMesh_FastDiscret_HeaderFile
#include <Handle_BRepMesh_FastDiscret.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _TColStd_SequenceOfInteger_HeaderFile
#include <TColStd_SequenceOfInteger.hxx>
#endif
#ifndef _Handle_MeshTest_DrawableUVDomain_HeaderFile
#include <Handle_MeshTest_DrawableUVDomain.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Draw_Drawable3D_HeaderFile
#include <Draw_Drawable3D.hxx>
#endif
#ifndef _Handle_Draw_Drawable3D_HeaderFile
#include <Handle_Draw_Drawable3D.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class BRepMesh_FastDiscret;
class MeshTest_DrawableUVDomain;
class TopoDS_Shape;
class TColStd_SequenceOfInteger;
class Draw_Display;
class Draw_Drawable3D;
class Draw_Interpretor;


//! A  drawable  mesh.   It  contains  a  sequence  of <br>
//!          highlighted edges and highlighted vertices. <br>
class MeshTest_DrawableMesh : public Draw_Drawable3D {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT MeshTest_DrawableMesh();


Standard_EXPORT MeshTest_DrawableMesh(const TopoDS_Shape& S,const Standard_Real Deflect,const Standard_Boolean Partage,const Standard_Boolean InShape = Standard_False);


Standard_EXPORT MeshTest_DrawableMesh(const Handle(BRepMesh_FastDiscret)& Tr);


Standard_EXPORT   void AddInShape(const Standard_Boolean inshape) ;


Standard_EXPORT   void Add(const TopoDS_Shape& S) ;


Standard_EXPORT   TColStd_SequenceOfInteger& Edges() ;


Standard_EXPORT   TColStd_SequenceOfInteger& Vertices() ;


Standard_EXPORT   TColStd_SequenceOfInteger& Triangles() ;


Standard_EXPORT   void DrawOn(Draw_Display& dis) const;


Standard_EXPORT virtual  Handle_Draw_Drawable3D Copy() const;


Standard_EXPORT   void SetDrawableUV(const Handle(MeshTest_DrawableUVDomain)& d) ;


Standard_EXPORT  const Handle_MeshTest_DrawableUVDomain& DrawableUV() const;


Standard_EXPORT   Handle_MeshTest_DrawableUVDomain& ChangeDrawableUV() ;


Standard_EXPORT virtual  void Dump(Standard_OStream& S) const;


Standard_EXPORT virtual  void Whatis(Draw_Interpretor& S) const;


Standard_EXPORT   Handle_BRepMesh_FastDiscret Mesh() const;
//Standard_EXPORT ~MeshTest_DrawableMesh();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_BRepMesh_FastDiscret myMesh;
Standard_Real myDeflection;
TColStd_SequenceOfInteger myEdges;
TColStd_SequenceOfInteger myVertices;
TColStd_SequenceOfInteger myTriangles;
Handle_MeshTest_DrawableUVDomain myDrawableUV;
Standard_Boolean myinshape;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
