// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _MeshVS_Drawer_HeaderFile
#define _MeshVS_Drawer_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_MeshVS_Drawer_HeaderFile
#include <Handle_MeshVS_Drawer.hxx>
#endif

#ifndef _TColStd_DataMapOfIntegerInteger_HeaderFile
#include <TColStd_DataMapOfIntegerInteger.hxx>
#endif
#ifndef _MeshVS_DataMapOfIntegerBoolean_HeaderFile
#include <MeshVS_DataMapOfIntegerBoolean.hxx>
#endif
#ifndef _TColStd_DataMapOfIntegerReal_HeaderFile
#include <TColStd_DataMapOfIntegerReal.hxx>
#endif
#ifndef _MeshVS_DataMapOfIntegerColor_HeaderFile
#include <MeshVS_DataMapOfIntegerColor.hxx>
#endif
#ifndef _MeshVS_DataMapOfIntegerMaterial_HeaderFile
#include <MeshVS_DataMapOfIntegerMaterial.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Quantity_Color;
class Graphic3d_MaterialAspect;


//! This class provided the common interface to share between classes <br>
//!  big set of constants affecting to object appearance. By default, this class <br>
//! can store integers, doubles, OCC colors, OCC materials. Each of OCC enum members <br>
//! can be stored as integers. <br>
class MeshVS_Drawer : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! This method copies other drawer contents to this. <br>
Standard_EXPORT virtual  void Assign(const Handle(MeshVS_Drawer)& aDrawer) ;


Standard_EXPORT   void SetInteger(const Standard_Integer Key,const Standard_Integer Value) ;


Standard_EXPORT   void SetDouble(const Standard_Integer Key,const Standard_Real Value) ;


Standard_EXPORT   void SetBoolean(const Standard_Integer Key,const Standard_Boolean Value) ;


Standard_EXPORT   void SetColor(const Standard_Integer Key,const Quantity_Color& Value) ;


Standard_EXPORT   void SetMaterial(const Standard_Integer Key,const Graphic3d_MaterialAspect& Value) ;


Standard_EXPORT   Standard_Boolean GetInteger(const Standard_Integer Key,Standard_Integer& Value) const;


Standard_EXPORT   Standard_Boolean GetDouble(const Standard_Integer Key,Standard_Real& Value) const;


Standard_EXPORT   Standard_Boolean GetBoolean(const Standard_Integer Key,Standard_Boolean& Value) const;


Standard_EXPORT   Standard_Boolean GetColor(const Standard_Integer Key,Quantity_Color& Value) const;


Standard_EXPORT   Standard_Boolean GetMaterial(const Standard_Integer Key,Graphic3d_MaterialAspect& Value) const;


Standard_EXPORT   Standard_Boolean RemoveInteger(const Standard_Integer Key) ;


Standard_EXPORT   Standard_Boolean RemoveDouble(const Standard_Integer Key) ;


Standard_EXPORT   Standard_Boolean RemoveBoolean(const Standard_Integer Key) ;


Standard_EXPORT   Standard_Boolean RemoveColor(const Standard_Integer Key) ;


Standard_EXPORT   Standard_Boolean RemoveMaterial(const Standard_Integer Key) ;
//Standard_EXPORT ~MeshVS_Drawer();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TColStd_DataMapOfIntegerInteger myIntegers;
MeshVS_DataMapOfIntegerBoolean myBooleans;
TColStd_DataMapOfIntegerReal myDoubles;
MeshVS_DataMapOfIntegerColor myColors;
MeshVS_DataMapOfIntegerMaterial myMaterials;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
