// File generated by CPPExt (Persistent CSFDB)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.
#ifndef _PBRep_CurveRepresentation_HeaderFile
#define _PBRep_CurveRepresentation_HeaderFile

#ifndef _Handle_PBRep_CurveRepresentation_HeaderFile
#include <Handle_PBRep_CurveRepresentation.hxx>
#endif
#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif

#ifndef _PTopLoc_Location_HeaderFile
#include <PTopLoc_Location.hxx>
#endif
#ifndef _Handle_PBRep_CurveRepresentation_HeaderFile
#include <Handle_PBRep_CurveRepresentation.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Persistent_HeaderFile
#include <Standard_Persistent.hxx>
#endif
class PTopLoc_Location;


class PBRep_CurveRepresentation : public Standard_Persistent {

public:

 // Methods PUBLIC
 // 


Standard_EXPORT   PTopLoc_Location Location() const;


Standard_EXPORT   Handle_PBRep_CurveRepresentation Next() const;


Standard_EXPORT   void Next(const Handle(PBRep_CurveRepresentation)& N) ;

//! A 3D curve representation. <br>
Standard_EXPORT virtual  Standard_Boolean IsCurve3D() const;

//! A curve in the parametric space of a surface. <br>
Standard_EXPORT virtual  Standard_Boolean IsCurveOnSurface() const;

//! A continuity between two surfaces. <br>
Standard_EXPORT virtual  Standard_Boolean IsRegularity() const;

//! A curve with two parametric   curves  on the  same <br>
//!          surface. <br>
Standard_EXPORT virtual  Standard_Boolean IsCurveOnClosedSurface() const;


Standard_EXPORT virtual  Standard_Boolean IsGCurve() const;


Standard_EXPORT virtual  Standard_Boolean IsPolygon3D() const;


Standard_EXPORT virtual  Standard_Boolean IsPolygonOnTriangulation() const;


Standard_EXPORT virtual  Standard_Boolean IsPolygonOnClosedTriangulation() const;


Standard_EXPORT virtual  Standard_Boolean IsPolygonOnSurface() const;


Standard_EXPORT virtual  Standard_Boolean IsPolygonOnClosedSurface() const;
//Standard_EXPORT ~PBRep_CurveRepresentation();
PBRep_CurveRepresentation( )
{
  
}

PBRep_CurveRepresentation(const Storage_stCONSTclCOM& a) : Standard_Persistent(a)
{
  
}

    const PTopLoc_Location& _CSFDB_GetPBRep_CurveRepresentationmyLocation() const { return myLocation; }
    Handle(PBRep_CurveRepresentation) _CSFDB_GetPBRep_CurveRepresentationmyNext() const { return myNext; }
    void _CSFDB_SetPBRep_CurveRepresentationmyNext(const Handle(PBRep_CurveRepresentation)& p) { myNext = p; }



 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
// Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


Standard_EXPORT PBRep_CurveRepresentation(const PTopLoc_Location& L);

 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

 // Fields PRIVATE
 //
PTopLoc_Location myLocation;
Handle_PBRep_CurveRepresentation myNext;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
