// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _PCDM_RetrievalDriver_HeaderFile
#define _PCDM_RetrievalDriver_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_PCDM_RetrievalDriver_HeaderFile
#include <Handle_PCDM_RetrievalDriver.hxx>
#endif

#ifndef _TCollection_ExtendedString_HeaderFile
#include <TCollection_ExtendedString.hxx>
#endif
#ifndef _PCDM_Reader_HeaderFile
#include <PCDM_Reader.hxx>
#endif
#ifndef _Handle_CDM_MetaData_HeaderFile
#include <Handle_CDM_MetaData.hxx>
#endif
#ifndef _PCDM_ReferenceIterator_HeaderFile
#include <PCDM_ReferenceIterator.hxx>
#endif
#ifndef _Handle_CDM_Document_HeaderFile
#include <Handle_CDM_Document.hxx>
#endif
#ifndef _Handle_CDM_Application_HeaderFile
#include <Handle_CDM_Application.hxx>
#endif
#ifndef _Handle_PCDM_Document_HeaderFile
#include <Handle_PCDM_Document.hxx>
#endif
#ifndef _Handle_Storage_Schema_HeaderFile
#include <Handle_Storage_Schema.hxx>
#endif
#ifndef _Handle_CDM_MessageDriver_HeaderFile
#include <Handle_CDM_MessageDriver.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class Standard_NoSuchObject;
class PCDM_DriverError;
class CDM_MetaData;
class TCollection_ExtendedString;
class CDM_Document;
class CDM_Application;
class PCDM_Document;
class Storage_Schema;
class TColStd_SequenceOfExtendedString;
class CDM_MessageDriver;
class PCDM_SequenceOfReference;
class TCollection_AsciiString;



class PCDM_RetrievalDriver : public PCDM_Reader {

public:
 // Methods PUBLIC
 // 

//!  Warning -  raises DriverError if an error occurs during inside the <br>
//!          Make method. <br>//! retrieves the content of the file into a new Document. <br>
//! <br>
//!          by  default  Read will  use the Schema method to read the file <br>
//!          into a persistent document. and the Make   method to build a <br>
//!          transient document. <br>
//! <br>
Standard_EXPORT virtual  void Read(const TCollection_ExtendedString& aFileName,const Handle(CDM_Document)& aNewDocument,const Handle(CDM_Application)& anApplication) ;


Standard_EXPORT virtual  void Make(const Handle(PCDM_Document)& aPCDM,const Handle(CDM_Document)& aNewDocument)  = 0;


Standard_EXPORT virtual  TCollection_ExtendedString SchemaName() const = 0;


Standard_EXPORT virtual  void LoadExtensions(const Handle(Storage_Schema)& aSchema,const TColStd_SequenceOfExtendedString& Extensions,const Handle(CDM_MessageDriver)& theMsgDriver) ;


Standard_EXPORT static  void RaiseIfUnknownTypes(const Handle(Storage_Schema)& aSchema,const TCollection_ExtendedString& aFileName) ;


Standard_EXPORT static  Standard_Integer DocumentVersion(const TCollection_ExtendedString& aFileName,const Handle(CDM_MessageDriver)& theMsgDriver) ;


Standard_EXPORT static  Standard_Integer ReferenceCounter(const TCollection_ExtendedString& aFileName,const Handle(CDM_MessageDriver)& theMsgDriver) ;


Standard_EXPORT   void SetFormat(const TCollection_ExtendedString& aformat) ;


Standard_EXPORT   TCollection_ExtendedString GetFormat() const;
//Standard_EXPORT ~PCDM_RetrievalDriver();


friend 

Standard_EXPORT   void PCDM_ReferenceIterator::Init(const Handle(CDM_MetaData)& aMetaData) ;


 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT static  void References(const TCollection_ExtendedString& aFileName,PCDM_SequenceOfReference& theReferences,const Handle(CDM_MessageDriver)& theMsgDriver) ;


Standard_EXPORT static  void Extensions(const TCollection_ExtendedString& aFileName,TColStd_SequenceOfExtendedString& theExtensions,const Handle(CDM_MessageDriver)& theMsgDriver) ;


Standard_EXPORT static  void UserInfo(const TCollection_ExtendedString& aFileName,const TCollection_AsciiString& Start,const TCollection_AsciiString& End,TColStd_SequenceOfExtendedString& theUserInfo,const Handle(CDM_MessageDriver)& theMsgDriver) ;


 // Fields PRIVATE
 //
TCollection_ExtendedString myFormat;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
