// File generated by CPPExt (Persistent CSFDB)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.
#ifndef _PGeom_BSplineCurve_HeaderFile
#define _PGeom_BSplineCurve_HeaderFile

#ifndef _Handle_PGeom_BSplineCurve_HeaderFile
#include <Handle_PGeom_BSplineCurve.hxx>
#endif
#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_PColgp_HArray1OfPnt_HeaderFile
#include <Handle_PColgp_HArray1OfPnt.hxx>
#endif
#ifndef _Handle_PColStd_HArray1OfReal_HeaderFile
#include <Handle_PColStd_HArray1OfReal.hxx>
#endif
#ifndef _Handle_PColStd_HArray1OfInteger_HeaderFile
#include <Handle_PColStd_HArray1OfInteger.hxx>
#endif
#ifndef _PGeom_BoundedCurve_HeaderFile
#include <PGeom_BoundedCurve.hxx>
#endif
class PColgp_HArray1OfPnt;
class PColStd_HArray1OfReal;
class PColStd_HArray1OfInteger;


class PGeom_BSplineCurve : public PGeom_BoundedCurve {

public:

 // Methods PUBLIC
 // 

//! Creates a BSplineCurve with default values. <br>
Standard_EXPORT PGeom_BSplineCurve();

//! Creates a BSplineCurve with these field values. <br>
Standard_EXPORT PGeom_BSplineCurve(const Standard_Boolean aRational,const Standard_Boolean aPeriodic,const Standard_Integer aSpineDegree,const Handle(PColgp_HArray1OfPnt)& aPoles,const Handle(PColStd_HArray1OfReal)& aWeights,const Handle(PColStd_HArray1OfReal)& aKnots,const Handle(PColStd_HArray1OfInteger)& aMultiplicities);

//!Set the field periodic with <aPeriodic>. <br>
Standard_EXPORT   void Periodic(const Standard_Boolean aPeriodic) ;

//!Returns the value of the field periodic. <br>
Standard_EXPORT   Standard_Boolean Periodic() const;

//!Set  the   value  of  the    field rational   with <br>
//!         <aRational>. <br>
Standard_EXPORT   void Rational(const Standard_Boolean aRational) ;

//!Returns the value of the field rational. <br>
Standard_EXPORT   Standard_Boolean Rational() const;

//! Set the value of the field spineDegree with <aSpineDegree>. <br>
Standard_EXPORT   void SpineDegree(const Standard_Integer aSpineDegree) ;

//! Returns the value of the field spineDegree. <br>
Standard_EXPORT   Standard_Integer SpineDegree() const;

//! Set the value of the field poles with <aPoles>. <br>
Standard_EXPORT   void Poles(const Handle(PColgp_HArray1OfPnt)& aPoles) ;

//! Returns the value of the field poles. <br>
Standard_EXPORT   Handle_PColgp_HArray1OfPnt Poles() const;

//! Set the value of the field weights with <aWeights>. <br>
Standard_EXPORT   void Weights(const Handle(PColStd_HArray1OfReal)& aWeights) ;

//! Returns the the value of the field weights. <br>
Standard_EXPORT   Handle_PColStd_HArray1OfReal Weights() const;

//!  Set the field knots with <aKnots>. <br>
//!  The multiplicity of the knots are not modified. <br>
Standard_EXPORT   void Knots(const Handle(PColStd_HArray1OfReal)& aKnots) ;

//! returns the value of the field knots. <br>
Standard_EXPORT   Handle_PColStd_HArray1OfReal Knots() const;

//!  Set the field multiplicities with <aMultiplicities>. <br>
Standard_EXPORT   void Multiplicities(const Handle(PColStd_HArray1OfInteger)& aMultiplicities) ;

//! returns the value of the field multiplicities. <br>
Standard_EXPORT   Handle_PColStd_HArray1OfInteger Multiplicities() const;
//Standard_EXPORT ~PGeom_BSplineCurve();
PGeom_BSplineCurve(const Storage_stCONSTclCOM& a) : PGeom_BoundedCurve(a)
{
  
}

    Standard_Boolean _CSFDB_GetPGeom_BSplineCurverational() const { return rational; }
    void _CSFDB_SetPGeom_BSplineCurverational(const Standard_Boolean p) { rational = p; }
    Standard_Boolean _CSFDB_GetPGeom_BSplineCurveperiodic() const { return periodic; }
    void _CSFDB_SetPGeom_BSplineCurveperiodic(const Standard_Boolean p) { periodic = p; }
    Standard_Integer _CSFDB_GetPGeom_BSplineCurvespineDegree() const { return spineDegree; }
    void _CSFDB_SetPGeom_BSplineCurvespineDegree(const Standard_Integer p) { spineDegree = p; }
    Handle(PColgp_HArray1OfPnt) _CSFDB_GetPGeom_BSplineCurvepoles() const { return poles; }
    void _CSFDB_SetPGeom_BSplineCurvepoles(const Handle(PColgp_HArray1OfPnt)& p) { poles = p; }
    Handle(PColStd_HArray1OfReal) _CSFDB_GetPGeom_BSplineCurveweights() const { return weights; }
    void _CSFDB_SetPGeom_BSplineCurveweights(const Handle(PColStd_HArray1OfReal)& p) { weights = p; }
    Handle(PColStd_HArray1OfReal) _CSFDB_GetPGeom_BSplineCurveknots() const { return knots; }
    void _CSFDB_SetPGeom_BSplineCurveknots(const Handle(PColStd_HArray1OfReal)& p) { knots = p; }
    Handle(PColStd_HArray1OfInteger) _CSFDB_GetPGeom_BSplineCurvemultiplicities() const { return multiplicities; }
    void _CSFDB_SetPGeom_BSplineCurvemultiplicities(const Handle(PColStd_HArray1OfInteger)& p) { multiplicities = p; }



 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
// Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

 // Fields PRIVATE
 //
Standard_Boolean rational;
Standard_Boolean periodic;
Standard_Integer spineDegree;
Handle_PColgp_HArray1OfPnt poles;
Handle_PColStd_HArray1OfReal weights;
Handle_PColStd_HArray1OfReal knots;
Handle_PColStd_HArray1OfInteger multiplicities;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
