// File generated by CPPExt (Persistent CSFDB)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.
#ifndef _PGeom_OffsetCurve_HeaderFile
#define _PGeom_OffsetCurve_HeaderFile

#ifndef _Handle_PGeom_OffsetCurve_HeaderFile
#include <Handle_PGeom_OffsetCurve.hxx>
#endif
#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif

#ifndef _Handle_PGeom_Curve_HeaderFile
#include <Handle_PGeom_Curve.hxx>
#endif
#ifndef _gp_Dir_HeaderFile
#include <gp_Dir.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _PGeom_Curve_HeaderFile
#include <PGeom_Curve.hxx>
#endif
class PGeom_Curve;
class gp_Dir;


class PGeom_OffsetCurve : public PGeom_Curve {

public:

 // Methods PUBLIC
 // 

//! Creates an OffsetCurve with default values. <br>
Standard_EXPORT PGeom_OffsetCurve();

//! <aBasisCurve> is  the basis curve, <aOffsetValue> <br>
//!         is the distance between <me> and the basis curve at <br>
//!         any point.    <aOffsetDirection>  defines the fixed <br>
//!         reference direction (offset direction). <br>
Standard_EXPORT PGeom_OffsetCurve(const Handle(PGeom_Curve)& aBasisCurve,const Standard_Real aOffsetValue,const gp_Dir& aOffsetDirection);

//! Set the field basisCurve with <aBasisCurve>. <br>
Standard_EXPORT   void BasisCurve(const Handle(PGeom_Curve)& aBasisCurve) ;

//! The basis curve can be an offset curve. <br>
Standard_EXPORT   Handle_PGeom_Curve BasisCurve() const;

//! Set the value of  the field offsetDirection with <br>
//!  <aOffsetDirection>. <br>
Standard_EXPORT   void OffsetDirection(const gp_Dir& aOffsetDirection) ;

//! Returns the direction of offset. <br>
Standard_EXPORT   gp_Dir OffsetDirection() const;

//! Set the field offsetValue with <aOffsetValue>. <br>
Standard_EXPORT   void OffsetValue(const Standard_Real aOffsetValue) ;

//! Returns the value of the field offsetValue. <br>
Standard_EXPORT   Standard_Real OffsetValue() const;
//Standard_EXPORT ~PGeom_OffsetCurve();
PGeom_OffsetCurve(const Storage_stCONSTclCOM& a) : PGeom_Curve(a)
{
  
}

    Handle(PGeom_Curve) _CSFDB_GetPGeom_OffsetCurvebasisCurve() const { return basisCurve; }
    void _CSFDB_SetPGeom_OffsetCurvebasisCurve(const Handle(PGeom_Curve)& p) { basisCurve = p; }
    const gp_Dir& _CSFDB_GetPGeom_OffsetCurveoffsetDirection() const { return offsetDirection; }
    Standard_Real _CSFDB_GetPGeom_OffsetCurveoffsetValue() const { return offsetValue; }
    void _CSFDB_SetPGeom_OffsetCurveoffsetValue(const Standard_Real p) { offsetValue = p; }



 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
// Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

 // Fields PRIVATE
 //
Handle_PGeom_Curve basisCurve;
gp_Dir offsetDirection;
Standard_Real offsetValue;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
