// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Prs2d_Drawer_HeaderFile
#define _Prs2d_Drawer_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Prs2d_Drawer_HeaderFile
#include <Handle_Prs2d_Drawer.hxx>
#endif

#ifndef _Prs2d_DataMapOfAspectRoot_HeaderFile
#include <Prs2d_DataMapOfAspectRoot.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Handle_Prs2d_AspectRoot_HeaderFile
#include <Handle_Prs2d_AspectRoot.hxx>
#endif
#ifndef _Prs2d_AspectName_HeaderFile
#include <Prs2d_AspectName.hxx>
#endif
class Prs2d_AspectRoot;


//! Graphic attributes management <br>
//!           Qualifies how the presentation algorithms compute <br>
//!           the presentation of a specific kind of object. <br>
//!           This includes for example color, width and type <br>
//!           of lines... <br>
class Prs2d_Drawer : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! Initializes graphic attribute manager <br>
Standard_EXPORT Prs2d_Drawer();

//! Returns a link with Prs2d_Drawer AspectName, <br>
//!          which provides settings for object "anAspectName" <br>
//!          used to display "anAspectName" <br>
Standard_EXPORT virtual  Handle_Prs2d_AspectRoot FindAspect(const Prs2d_AspectName anAspectName) const;

//! Sets the Aspect <anAspectRoot> of the Drawer <br>
Standard_EXPORT   void SetAspect(const Handle(Prs2d_AspectRoot)& anAspectRoot,const Prs2d_AspectName anAspectName) ;

//! defines the maximum value allowed for the first and last <br>
//!          parameters of an infinite line. <br>
//!          Default value: 500000. <br>
Standard_EXPORT virtual  void SetMaxParameterValue(const Standard_Real Value) ;

//! Indicates the maximum value allowed for the first and last <br>
//!          parameters of an infinite line. <br>
Standard_EXPORT virtual  Standard_Real MaxParameterValue() const;
//Standard_EXPORT ~Prs2d_Drawer();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //
Prs2d_DataMapOfAspectRoot myDataMapAspectRoot;
Standard_Real myMaxParameterValue;


private: 

 // Methods PRIVATE
 // 

//! Initializes Aspect classes data map <br>
Standard_EXPORT   void InitAspectRootMap() ;


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
