// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Prs3d_AngleAspect_HeaderFile
#define _Prs3d_AngleAspect_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Prs3d_AngleAspect_HeaderFile
#include <Handle_Prs3d_AngleAspect.hxx>
#endif

#ifndef _Handle_Prs3d_LineAspect_HeaderFile
#include <Handle_Prs3d_LineAspect.hxx>
#endif
#ifndef _Handle_Prs3d_ArrowAspect_HeaderFile
#include <Handle_Prs3d_ArrowAspect.hxx>
#endif
#ifndef _Handle_Prs3d_TextAspect_HeaderFile
#include <Handle_Prs3d_TextAspect.hxx>
#endif
#ifndef _Prs3d_CompositeAspect_HeaderFile
#include <Prs3d_CompositeAspect.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class Prs3d_LineAspect;
class Prs3d_ArrowAspect;
class Prs3d_TextAspect;


//! A framework for defining how an angle will be <br>
//! displayed in a presentation. Aspects of angle display include: <br>
//! -   display of the arrow pointing to the angle <br>
//! -   display of the line making up the shaft of the arrow <br>
//! -   display of the text referring to the angle. <br>
//!   The definition set by this class is then passed to the <br>
//! attribute manager Prs3d_Drawer. <br>
//! Any object which requires a value for angle aspect as <br>
//! an argument may then be given the attribute manager <br>
//! as a substitute argument in the form of a field such as <br>
//! myDrawer for example. <br>
class Prs3d_AngleAspect : public Prs3d_CompositeAspect {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT Prs3d_AngleAspect();

//! Returns the setting determining how the line making <br>
//! up the shaft of the arrow will be displayed. <br>
Standard_EXPORT   Handle_Prs3d_LineAspect LineAspect() const;

//! Sets how the line making up the shaft of an arrow will be displayed. <br>
Standard_EXPORT   void SetLineAspect(const Handle(Prs3d_LineAspect)& anAspect) ;

//! Returns the setting determining how text in the <br>
//! presentation of an angle will be displayed. <br>
Standard_EXPORT   Handle_Prs3d_TextAspect TextAspect() const;

//! Sets how text in the presentation of an angle will be displayed. <br>
Standard_EXPORT   void SetTextAspect(const Handle(Prs3d_TextAspect)& anAspect) ;

//! Returns the setting determining how an arrow head <br>
//! which points to an angle will be displayed. <br>
Standard_EXPORT   Handle_Prs3d_ArrowAspect ArrowAspect() const;

//! Sets how an arrow head which points to an angle will be displayed. <br>
Standard_EXPORT   void SetArrowAspect(const Handle(Prs3d_ArrowAspect)& anAspect) ;


Standard_EXPORT   void Print(Standard_OStream& s) const;
//Standard_EXPORT ~Prs3d_AngleAspect();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Prs3d_LineAspect myLineAspect;
Handle_Prs3d_ArrowAspect myArrowAspect;
Handle_Prs3d_TextAspect myTextAspect;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
