// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Prs3d_LengthAspect_HeaderFile
#define _Prs3d_LengthAspect_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Prs3d_LengthAspect_HeaderFile
#include <Handle_Prs3d_LengthAspect.hxx>
#endif

#ifndef _Handle_Prs3d_LineAspect_HeaderFile
#include <Handle_Prs3d_LineAspect.hxx>
#endif
#ifndef _Handle_Prs3d_ArrowAspect_HeaderFile
#include <Handle_Prs3d_ArrowAspect.hxx>
#endif
#ifndef _Handle_Prs3d_TextAspect_HeaderFile
#include <Handle_Prs3d_TextAspect.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Prs3d_CompositeAspect_HeaderFile
#include <Prs3d_CompositeAspect.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class Prs3d_LineAspect;
class Prs3d_ArrowAspect;
class Prs3d_TextAspect;


//! defines the attributes when drawing a Length Presentation. <br>
class Prs3d_LengthAspect : public Prs3d_CompositeAspect {

public:
 // Methods PUBLIC
 // 

//! Constructs an empty framework to define the display of lengths. <br>
Standard_EXPORT Prs3d_LengthAspect();

//! Returns the settings for the display of lines used in presentation of lengths. <br>
Standard_EXPORT   Handle_Prs3d_LineAspect LineAspect() const;

//! Sets the display attributes of lines used in presentation of lengths. <br>
Standard_EXPORT   void SetLineAspect(const Handle(Prs3d_LineAspect)& anAspect) ;

//! Returns the settings for displaying a right-pointing arrow. <br>
Standard_EXPORT   Handle_Prs3d_ArrowAspect Arrow1Aspect() const;

//!   Sets the display attributes of the first arrow used in presentation of lengths. <br>
Standard_EXPORT   void SetArrow1Aspect(const Handle(Prs3d_ArrowAspect)& anAspect) ;

//! Returns the settings for displaying a left-pointing arrow. <br>
Standard_EXPORT   Handle_Prs3d_ArrowAspect Arrow2Aspect() const;

//! Sets the display attributes of the second arrow used in presentation of lengths. <br>
Standard_EXPORT   void SetArrow2Aspect(const Handle(Prs3d_ArrowAspect)& anAspect) ;

//! Returns the settings for the display of text used in presentation of lengths. <br>
Standard_EXPORT   Handle_Prs3d_TextAspect TextAspect() const;

//! Sets the display attributes of text used in presentation of lengths. <br>
Standard_EXPORT   void SetTextAspect(const Handle(Prs3d_TextAspect)& anAspect) ;

//! Sets the DrawFirstArrow attributes to active. <br>
Standard_EXPORT   void SetDrawFirstArrow(const Standard_Boolean draw) ;

//! Returns true if the first arrow can be drawn. <br>
Standard_EXPORT   Standard_Boolean DrawFirstArrow() const;

//! Sets the DrawSecondArrow attributes to active. <br>
Standard_EXPORT   void SetDrawSecondArrow(const Standard_Boolean draw) ;

//! Returns true if the second arrow can be drawn. <br>
Standard_EXPORT   Standard_Boolean DrawSecondArrow() const;


Standard_EXPORT   void Print(Standard_OStream& s) const;
//Standard_EXPORT ~Prs3d_LengthAspect();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Prs3d_LineAspect myLineAspect;
Handle_Prs3d_ArrowAspect myArrow1Aspect;
Handle_Prs3d_ArrowAspect myArrow2Aspect;
Handle_Prs3d_TextAspect myTextAspect;
Standard_Boolean myDrawFirstArrow;
Standard_Boolean myDrawSecondArrow;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
