// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Select3D_SensitiveCircle_HeaderFile
#define _Select3D_SensitiveCircle_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Select3D_SensitiveCircle_HeaderFile
#include <Handle_Select3D_SensitiveCircle.hxx>
#endif

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Select3D_SensitivePoly_HeaderFile
#include <Select3D_SensitivePoly.hxx>
#endif
#ifndef _Handle_SelectBasics_EntityOwner_HeaderFile
#include <Handle_SelectBasics_EntityOwner.hxx>
#endif
#ifndef _Handle_Geom_Circle_HeaderFile
#include <Handle_Geom_Circle.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Handle_TColgp_HArray1OfPnt_HeaderFile
#include <Handle_TColgp_HArray1OfPnt.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class SelectBasics_EntityOwner;
class Geom_Circle;
class TColgp_HArray1OfPnt;
class TColgp_Array1OfPnt;
class TColgp_Array1OfPnt2d;
class Bnd_Box2d;
class gp_Lin;
class gp_Pnt;


//! A framework to define sensitive 3D arcs and circles. <br>
class Select3D_SensitiveCircle : public Select3D_SensitivePoly {

public:
 // Methods PUBLIC
 // 

//! Constructs the sensitive circle object defined by the <br>
//! owner OwnerId, the circle Circle, the Boolean <br>
//! FilledCircle and the number of points NbOfPoints. <br>
Standard_EXPORT Select3D_SensitiveCircle(const Handle(SelectBasics_EntityOwner)& OwnerId,const Handle(Geom_Circle)& TheCircle,const Standard_Boolean FilledCircle = Standard_False,const Standard_Integer NbOfPoints = 6);

//! Constructs the sensitive arc object defined by the <br>
//! owner OwnerId, the circle Circle, the parameters u1 <br>
//! and u2, the Boolean FilledCircle and the number of points NbOfPoints. <br>
//! u1 and u2 define the first and last points of the arc on Circle. <br>
Standard_EXPORT Select3D_SensitiveCircle(const Handle(SelectBasics_EntityOwner)& OwnerId,const Handle(Geom_Circle)& TheCircle,const Standard_Real u1,const Standard_Real u2,const Standard_Boolean FilledCircle = Standard_False,const Standard_Integer NbOfPoints = 6);

//! Constructs the sensitive circle object defined by the <br>
//! owner OwnerId, the array of triangles apolyg3d, and the Boolean FilledCircle. <br>
//! apolyg3d is an array of consecutive triangles on the <br>
//! circle. The triangle i+1 lies on the intersection of the <br>
//! tangents to the circle of i and i+2. <br>
Standard_EXPORT Select3D_SensitiveCircle(const Handle(SelectBasics_EntityOwner)& OwnerId,const Handle(TColgp_HArray1OfPnt)& apolyg3d,const Standard_Boolean FilledCircle = Standard_False);

//! Constructs the sensitive circle object defined by the <br>
//! owner OwnerId, the array of points apolyg3d, and the Boolean FilledCircle. <br>
Standard_EXPORT Select3D_SensitiveCircle(const Handle(SelectBasics_EntityOwner)& OwnerId,const TColgp_Array1OfPnt& apolyg3d,const Standard_Boolean FilledCircle = Standard_False);


Standard_EXPORT   Standard_Boolean Matches(const Standard_Real X,const Standard_Real Y,const Standard_Real aTol,Standard_Real& DMin) ;


Standard_EXPORT   Standard_Boolean Matches(const Standard_Real XMin,const Standard_Real YMin,const Standard_Real XMax,const Standard_Real YMax,const Standard_Real aTol) ;


Standard_EXPORT virtual  Standard_Boolean Matches(const TColgp_Array1OfPnt2d& Polyline,const Bnd_Box2d& aBox,const Standard_Real aTol) ;


Standard_EXPORT   Standard_Real ComputeDepth(const gp_Lin& EyeLine) const;


Standard_EXPORT   void ArrayBounds(Standard_Integer& Low,Standard_Integer& Up) const;


Standard_EXPORT   gp_Pnt GetPoint3d(const Standard_Integer rank) const;


Standard_EXPORT virtual  void Dump(Standard_OStream& S,const Standard_Boolean FullDump = Standard_True) const;
//Standard_EXPORT ~Select3D_SensitiveCircle();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Boolean myFillStatus;
Standard_Integer myDetectedIndex;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
