// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _SelectBasics_HeaderFile
#define _SelectBasics_HeaderFile

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class SelectBasics_EntityOwner;
class SelectBasics_SortAlgo;
class SelectBasics_BasicTool;
class SelectBasics_SequenceOfAddress;
class SelectBasics_ListOfBox2d;
class SelectBasics_SequenceOfOwner;
class SelectBasics_SensitiveEntity;
class SelectBasics_ListOfSensitive;
class SelectBasics_SequenceNodeOfSequenceOfAddress;
class SelectBasics_ListNodeOfListOfBox2d;
class SelectBasics_ListIteratorOfListOfBox2d;
class SelectBasics_SequenceNodeOfSequenceOfOwner;
class SelectBasics_ListNodeOfListOfSensitive;
class SelectBasics_ListIteratorOfListOfSensitive;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//!  kernel of dynamic selection: <br>
//!           - contains the algorithm to sort the sensitive areas <br>
//!           before the selection action;->quick selection of <br>
//!           an item in a set of items... <br>
//!           - contains the entities able to give the algorithm <br>
//!             sensitive areas . <br>
class SelectBasics  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT static  Standard_Integer MaxOwnerPriority() ;


Standard_EXPORT static  Standard_Integer MinOwnerPriority() ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //

friend class SelectBasics_EntityOwner;
friend class SelectBasics_SortAlgo;
friend class SelectBasics_BasicTool;
friend class SelectBasics_SequenceOfAddress;
friend class SelectBasics_ListOfBox2d;
friend class SelectBasics_SequenceOfOwner;
friend class SelectBasics_SensitiveEntity;
friend class SelectBasics_ListOfSensitive;
friend class SelectBasics_SequenceNodeOfSequenceOfAddress;
friend class SelectBasics_ListNodeOfListOfBox2d;
friend class SelectBasics_ListIteratorOfListOfBox2d;
friend class SelectBasics_SequenceNodeOfSequenceOfOwner;
friend class SelectBasics_ListNodeOfListOfSensitive;
friend class SelectBasics_ListIteratorOfListOfSensitive;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
