// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _SelectMgr_SortCriterion_HeaderFile
#define _SelectMgr_SortCriterion_HeaderFile

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class SelectMgr_SortCriterion  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT SelectMgr_SortCriterion();


Standard_EXPORT SelectMgr_SortCriterion(const Standard_Integer aPriority,const Standard_Real aDepth,const Standard_Real aMinDist);

  void SetValues(const Standard_Integer Prior,const Standard_Real aDepth,const Standard_Real aMinDist) ;

  void SetPriority(const Standard_Integer P) ;

  void SetDepth(const Standard_Real D) ;

  void SetMinDist(const Standard_Real D) ;

  void Values(Standard_Integer& Prior,Standard_Real& Depth,Standard_Real& Dist) const;

  Standard_Integer Priority() const;

  Standard_Real Depth() const;

  Standard_Real MinDist() const;


Standard_EXPORT   Standard_Boolean IsGreater(const SelectMgr_SortCriterion& anOtherCriterion) const;
  Standard_Boolean operator >(const SelectMgr_SortCriterion& anOtherCriterion) const
{
  return IsGreater(anOtherCriterion);
}



Standard_EXPORT   Standard_Boolean IsLower(const SelectMgr_SortCriterion& anOtherCriterion) const;
  Standard_Boolean operator <(const SelectMgr_SortCriterion& anOtherCriterion) const
{
  return IsLower(anOtherCriterion);
}






protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer myPrior;
Standard_Real myDepth;
Standard_Real myDist;


};


#include <SelectMgr_SortCriterion.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
