// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _ShapeCustom_RestrictionParameters_HeaderFile
#define _ShapeCustom_RestrictionParameters_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_ShapeCustom_RestrictionParameters_HeaderFile
#include <Handle_ShapeCustom_RestrictionParameters.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif


//! This class is axuluary tool which contains parameters for <br>
//!          BSplineRestriction class. <br>
class ShapeCustom_RestrictionParameters : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! Sets default parameters. <br>
Standard_EXPORT ShapeCustom_RestrictionParameters();
//! Returns (modifiable) maximal degree of approximation. <br>
  Standard_Integer& GMaxDegree() ;
//! Returns (modifiable) maximal number of spans of <br>
//!          approximation. <br>
  Standard_Integer& GMaxSeg() ;
//! Sets flag for define if Plane converted to BSpline surface. <br>
  Standard_Boolean& ConvertPlane() ;
//! Sets flag for define if Bezier surface converted to BSpline <br>
//!          surface. <br>
  Standard_Boolean& ConvertBezierSurf() ;
//! Sets flag for define if surface of Revolution converted to <br>
//!          BSpline surface. <br>
  Standard_Boolean& ConvertRevolutionSurf() ;
//! Sets flag for define if surface of LinearExtrusion converted <br>
//!          to BSpline surface. <br>
  Standard_Boolean& ConvertExtrusionSurf() ;
//! Sets flag for define if Offset surface converted to BSpline <br>
//!          surface. <br>
  Standard_Boolean& ConvertOffsetSurf() ;
//! Sets Segment mode for surface. If Segment is True surface is <br>
//!          approximated in the bondaries of face lying on this surface. <br>
  Standard_Boolean& SegmentSurfaceMode() ;
//! Sets flag for define if 3d curve converted to BSpline curve. <br>
  Standard_Boolean& ConvertCurve3d() ;
//! Sets flag for define if Offset curve3d converted to BSpline <br>
//!          surface. <br>
  Standard_Boolean& ConvertOffsetCurv3d() ;
//! Returns (modifiable) flag for define if 2d curve converted <br>
//!          to BSpline curve. <br>
  Standard_Boolean& ConvertCurve2d() ;
//! Returns (modifiable) flag for define if Offset curve2d <br>
//!          converted to BSpline surface. <br>
  Standard_Boolean& ConvertOffsetCurv2d() ;
//Standard_EXPORT ~ShapeCustom_RestrictionParameters();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer myGMaxDegree;
Standard_Integer myGMaxSeg;
Standard_Boolean myConvPlane;
Standard_Boolean myConvBezierSurf;
Standard_Boolean myConvRevolSurf;
Standard_Boolean myConvExtrSurf;
Standard_Boolean myConvOffsetSurf;
Standard_Boolean mySegmentSurfaceMode;
Standard_Boolean myConvCurve3d;
Standard_Boolean myConvOffsetCurv3d;
Standard_Boolean myConvCurve2d;
Standard_Boolean myConvOffsetCurv2d;


};


#include <ShapeCustom_RestrictionParameters.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
