// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _ShapeUpgrade_ConvertCurve2dToBezier_HeaderFile
#define _ShapeUpgrade_ConvertCurve2dToBezier_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_ShapeUpgrade_ConvertCurve2dToBezier_HeaderFile
#include <Handle_ShapeUpgrade_ConvertCurve2dToBezier.hxx>
#endif

#ifndef _Handle_TColGeom2d_HSequenceOfCurve_HeaderFile
#include <Handle_TColGeom2d_HSequenceOfCurve.hxx>
#endif
#ifndef _Handle_TColStd_HSequenceOfReal_HeaderFile
#include <Handle_TColStd_HSequenceOfReal.hxx>
#endif
#ifndef _ShapeUpgrade_SplitCurve2d_HeaderFile
#include <ShapeUpgrade_SplitCurve2d.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class TColGeom2d_HSequenceOfCurve;
class TColStd_HSequenceOfReal;


//! converts/splits a 2d curve to a list of beziers <br>
class ShapeUpgrade_ConvertCurve2dToBezier : public ShapeUpgrade_SplitCurve2d {

public:
 // Methods PUBLIC
 // 

//! Empty constructor. <br>
Standard_EXPORT ShapeUpgrade_ConvertCurve2dToBezier();

//! Converts curve into a list of beziers, and stores the <br>
//!          splitting parameters on original curve. <br>
Standard_EXPORT virtual  void Compute() ;

//! Splits a list of beziers computed by Compute method according <br>
//!          the split values and splitting parameters. <br>
Standard_EXPORT virtual  void Build(const Standard_Boolean Segment) ;

//! Returns the list of splitted parameters in original curve <br>
//!          parametrisation. <br>
Standard_EXPORT   Handle_TColStd_HSequenceOfReal SplitParams() const;
//Standard_EXPORT ~ShapeUpgrade_ConvertCurve2dToBezier();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

//! Returns the list of bezier curves correspondent to original <br>
//!          curve. <br>
Standard_EXPORT   Handle_TColGeom2d_HSequenceOfCurve Segments() const;


 // Fields PRIVATE
 //
Handle_TColGeom2d_HSequenceOfCurve mySegments;
Handle_TColStd_HSequenceOfReal mySplitParams;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
