// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _ShapeUpgrade_SplitSurfaceContinuity_HeaderFile
#define _ShapeUpgrade_SplitSurfaceContinuity_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_ShapeUpgrade_SplitSurfaceContinuity_HeaderFile
#include <Handle_ShapeUpgrade_SplitSurfaceContinuity.hxx>
#endif

#ifndef _GeomAbs_Shape_HeaderFile
#include <GeomAbs_Shape.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _ShapeUpgrade_SplitSurface_HeaderFile
#include <ShapeUpgrade_SplitSurface.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif


//! Splits a Surface with a continuity criterion. <br>
//!          At the present moment C1 criterion is used only. <br>
//!          This tool works with tolerance. If C0 surface can be corrected <br>
//!          at a knot with given tolerance then the surface is corrected, <br>
//!          otherwise it is spltted at that knot. <br>
class ShapeUpgrade_SplitSurfaceContinuity : public ShapeUpgrade_SplitSurface {

public:
 // Methods PUBLIC
 // 

//! Empty constructor. <br>
Standard_EXPORT ShapeUpgrade_SplitSurfaceContinuity();

//! Sets criterion for splitting. <br>
Standard_EXPORT   void SetCriterion(const GeomAbs_Shape Criterion) ;

//! Sets tolerance. <br>
Standard_EXPORT   void SetTolerance(const Standard_Real Tol) ;


Standard_EXPORT virtual  void Compute(const Standard_Boolean Segment) ;
//Standard_EXPORT ~ShapeUpgrade_SplitSurfaceContinuity();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
GeomAbs_Shape myCriterion;
Standard_Real myTolerance;
Standard_Integer myCont;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
