// File generated by Schema (CallBack)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StdSchema_PDF_Attribute_HeaderFile
#define _StdSchema_PDF_Attribute_HeaderFile

#ifndef _Storage_Schema_HeaderFile
#include <Storage_Schema.hxx>
#endif
#ifndef _Storage_CallBack_HeaderFile_
#include <Storage_CallBack.hxx>
#endif
#ifndef _Storage_BaseDriver_HeaderFile_
#include <Storage_BaseDriver.hxx>
#endif

#ifndef _StdSchema_Standard_Persistent_HeaderFile_
#include <StdSchema_Standard_Persistent.hxx>
#endif


class Handle_PDF_Attribute;

class Handle_Standard_Type;
Standard_EXPORT Handle_Standard_Type& StdSchema_PDF_Attribute_Type_();
Standard_EXPORT Handle_Standard_Type& PDF_Attribute_Type_();
class Standard_Transient;
class Handle_Standard_Persistent;
class StdSchema_PDF_Attribute;

class Handle(StdSchema_PDF_Attribute) : public Handle(Storage_CallBack) {
  public:
    Handle(StdSchema_PDF_Attribute)() : Handle(Storage_CallBack)() {} 
    Handle(StdSchema_PDF_Attribute)(const Handle(StdSchema_PDF_Attribute)& aHandle) : Handle(Storage_CallBack)(aHandle) 
     {
     }

    Handle(StdSchema_PDF_Attribute)(const StdSchema_PDF_Attribute* anItem) : Handle(Storage_CallBack)((Storage_CallBack *)anItem) 
     {
     }

    Handle(StdSchema_PDF_Attribute)& operator=(const Handle(StdSchema_PDF_Attribute)& aHandle)
     {
      Assign(aHandle.Access());
      return *this;
     }

    Handle(StdSchema_PDF_Attribute)& operator=(const StdSchema_PDF_Attribute* anItem)
     {
      Assign((Standard_Transient *)anItem);
      return *this;
     }

    StdSchema_PDF_Attribute* operator->() 
     {
      return (StdSchema_PDF_Attribute *)ControlAccess();
     }

    StdSchema_PDF_Attribute* operator->() const 
     {
      return (StdSchema_PDF_Attribute *)ControlAccess();
     }

   ~Handle(StdSchema_PDF_Attribute)(){};

   Standard_EXPORT static const Handle(StdSchema_PDF_Attribute) DownCast(const Handle(Storage_CallBack)&);
};


class StdSchema_PDF_Attribute : public Storage_CallBack {
  public:
   StdSchema_PDF_Attribute() {};
   Standard_EXPORT static void SAdd(const Handle(PDF_Attribute)& ,const Handle(Storage_Schema)&);
   Standard_EXPORT static void SWrite(const Handle(Standard_Persistent)&,Storage_BaseDriver&,const Handle(Storage_Schema)&);
   Standard_EXPORT static void SRead(const Handle(Standard_Persistent)&,Storage_BaseDriver&,const Handle(Storage_Schema)&);

   Standard_EXPORT Handle_Standard_Persistent New() const;
   Standard_EXPORT void Add(const Handle(Standard_Persistent)&,const Handle(Storage_Schema)&) const;
   Standard_EXPORT void Write(const Handle(Standard_Persistent)&,Storage_BaseDriver&,const Handle(Storage_Schema)&) const;
   Standard_EXPORT void Read(const Handle(Standard_Persistent)&,Storage_BaseDriver&,const Handle(Storage_Schema)&) const;
   ~StdSchema_PDF_Attribute() {};

   Standard_EXPORT Standard_Boolean IsKind(const Handle(Standard_Type)& AType) const; 
   Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
};
#endif
