// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StepBasic_PersonOrganizationSelect_HeaderFile
#define _StepBasic_PersonOrganizationSelect_HeaderFile

#ifndef _StepData_SelectType_HeaderFile
#include <StepData_SelectType.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Handle_StepBasic_Person_HeaderFile
#include <Handle_StepBasic_Person.hxx>
#endif
#ifndef _Handle_StepBasic_Organization_HeaderFile
#include <Handle_StepBasic_Organization.hxx>
#endif
#ifndef _Handle_StepBasic_PersonAndOrganization_HeaderFile
#include <Handle_StepBasic_PersonAndOrganization.hxx>
#endif
class Standard_Transient;
class StepBasic_Person;
class StepBasic_Organization;
class StepBasic_PersonAndOrganization;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class StepBasic_PersonOrganizationSelect  : public StepData_SelectType {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Returns a PersonOrganizationSelect SelectType <br>
Standard_EXPORT StepBasic_PersonOrganizationSelect();

//! Recognizes a PersonOrganizationSelect Kind Entity that is : <br>
//!        1 -> Person <br>
//!        2 -> Organization <br>
//!        3 -> PersonAndOrganization <br>
//!        0 else <br>
Standard_EXPORT   Standard_Integer CaseNum(const Handle(Standard_Transient)& ent) const;

//! returns Value as a Person (Null if another type) <br>
Standard_EXPORT   Handle_StepBasic_Person Person() const;

//! returns Value as a Organization (Null if another type) <br>
Standard_EXPORT   Handle_StepBasic_Organization Organization() const;

//! returns Value as a PersonAndOrganization (Null if another type) <br>
Standard_EXPORT   Handle_StepBasic_PersonAndOrganization PersonAndOrganization() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
