// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StepData_GeneralModule_HeaderFile
#define _StepData_GeneralModule_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_StepData_GeneralModule_HeaderFile
#include <Handle_StepData_GeneralModule.hxx>
#endif

#ifndef _Interface_GeneralModule_HeaderFile
#include <Interface_GeneralModule.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Handle_Interface_Check_HeaderFile
#include <Handle_Interface_Check.hxx>
#endif
class Standard_Transient;
class Interface_EntityIterator;
class Interface_ShareTool;
class Interface_Check;
class Interface_CopyTool;


//! Specific features for General Services adapted to STEP <br>
class StepData_GeneralModule : public Interface_GeneralModule {

public:
 // Methods PUBLIC
 // 

//! Specific filling of the list of Entities shared by an Entity <br>
//!           <ent>. Can use the internal utility method Share, below <br>
Standard_EXPORT virtual  void FillSharedCase(const Standard_Integer casenum,const Handle(Standard_Transient)& ent,Interface_EntityIterator& iter) const = 0;

//! Specific Checking of an Entity <ent> <br>
Standard_EXPORT virtual  void CheckCase(const Standard_Integer casenum,const Handle(Standard_Transient)& ent,const Interface_ShareTool& shares,Handle(Interface_Check)& ach) const = 0;

//! Specific Copy ("Deep") from <entfrom> to <entto> (same type) <br>
//!           by using a TransferControl which provides its working Map. <br>
//!           Use method Transferred from TransferControl to work <br>//! Specific Copying of Implied References <br>
//!           A Default is provided which does nothing (must current case !) <br>
//!           Already copied references (by CopyFrom) must remain unchanged <br>
//!           Use method Search from TransferControl to work <br>
Standard_EXPORT virtual  void CopyCase(const Standard_Integer casenum,const Handle(Standard_Transient)& entfrom,const Handle(Standard_Transient)& entto,Interface_CopyTool& TC) const = 0;
//Standard_EXPORT ~StepData_GeneralModule();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
