// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StepFEA_CurveElementEndCoordinateSystem_HeaderFile
#define _StepFEA_CurveElementEndCoordinateSystem_HeaderFile

#ifndef _StepData_SelectType_HeaderFile
#include <StepData_SelectType.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Handle_StepFEA_FeaAxis2Placement3d_HeaderFile
#include <Handle_StepFEA_FeaAxis2Placement3d.hxx>
#endif
#ifndef _Handle_StepFEA_AlignedCurve3dElementCoordinateSystem_HeaderFile
#include <Handle_StepFEA_AlignedCurve3dElementCoordinateSystem.hxx>
#endif
#ifndef _Handle_StepFEA_ParametricCurve3dElementCoordinateSystem_HeaderFile
#include <Handle_StepFEA_ParametricCurve3dElementCoordinateSystem.hxx>
#endif
class Standard_Transient;
class StepFEA_FeaAxis2Placement3d;
class StepFEA_AlignedCurve3dElementCoordinateSystem;
class StepFEA_ParametricCurve3dElementCoordinateSystem;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Representation of STEP SELECT type CurveElementEndCoordinateSystem <br>
class StepFEA_CurveElementEndCoordinateSystem  : public StepData_SelectType {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Empty constructor <br>
Standard_EXPORT StepFEA_CurveElementEndCoordinateSystem();

//! Recognizes a kind of CurveElementEndCoordinateSystem select type <br>
//!          1 -> FeaAxis2Placement3d from StepFEA <br>
//!          2 -> AlignedCurve3dElementCoordinateSystem from StepFEA <br>
//!          3 -> ParametricCurve3dElementCoordinateSystem from StepFEA <br>
//!          0 else <br>
Standard_EXPORT   Standard_Integer CaseNum(const Handle(Standard_Transient)& ent) const;

//! Returns Value as FeaAxis2Placement3d (or Null if another type) <br>
Standard_EXPORT   Handle_StepFEA_FeaAxis2Placement3d FeaAxis2Placement3d() const;

//! Returns Value as AlignedCurve3dElementCoordinateSystem (or Null if another type) <br>
Standard_EXPORT   Handle_StepFEA_AlignedCurve3dElementCoordinateSystem AlignedCurve3dElementCoordinateSystem() const;

//! Returns Value as ParametricCurve3dElementCoordinateSystem (or Null if another type) <br>
Standard_EXPORT   Handle_StepFEA_ParametricCurve3dElementCoordinateSystem ParametricCurve3dElementCoordinateSystem() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
