// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StepShape_ReversibleTopologyItem_HeaderFile
#define _StepShape_ReversibleTopologyItem_HeaderFile

#ifndef _StepData_SelectType_HeaderFile
#include <StepData_SelectType.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Handle_StepShape_Edge_HeaderFile
#include <Handle_StepShape_Edge.hxx>
#endif
#ifndef _Handle_StepShape_Path_HeaderFile
#include <Handle_StepShape_Path.hxx>
#endif
#ifndef _Handle_StepShape_Face_HeaderFile
#include <Handle_StepShape_Face.hxx>
#endif
#ifndef _Handle_StepShape_FaceBound_HeaderFile
#include <Handle_StepShape_FaceBound.hxx>
#endif
#ifndef _Handle_StepShape_ClosedShell_HeaderFile
#include <Handle_StepShape_ClosedShell.hxx>
#endif
#ifndef _Handle_StepShape_OpenShell_HeaderFile
#include <Handle_StepShape_OpenShell.hxx>
#endif
class Standard_Transient;
class StepShape_Edge;
class StepShape_Path;
class StepShape_Face;
class StepShape_FaceBound;
class StepShape_ClosedShell;
class StepShape_OpenShell;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class StepShape_ReversibleTopologyItem  : public StepData_SelectType {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Returns a ReversibleTopologyItem SelectType <br>
Standard_EXPORT StepShape_ReversibleTopologyItem();

//! Recognizes a ReversibleTopologyItem Kind Entity that is : <br>
//!        1 -> Edge <br>
//!        2 -> Path <br>
//!        3 -> Face <br>
//!        4 -> FaceBound <br>
//!        5 -> ClosedShell <br>
//!        6 -> OpenShell <br>
//!        0 else <br>
Standard_EXPORT   Standard_Integer CaseNum(const Handle(Standard_Transient)& ent) const;

//! returns Value as a Edge (Null if another type) <br>
Standard_EXPORT   Handle_StepShape_Edge Edge() const;

//! returns Value as a Path (Null if another type) <br>
Standard_EXPORT   Handle_StepShape_Path Path() const;

//! returns Value as a Face (Null if another type) <br>
Standard_EXPORT   Handle_StepShape_Face Face() const;

//! returns Value as a FaceBound (Null if another type) <br>
Standard_EXPORT   Handle_StepShape_FaceBound FaceBound() const;

//! returns Value as a ClosedShell (Null if another type) <br>
Standard_EXPORT   Handle_StepShape_ClosedShell ClosedShell() const;

//! returns Value as a OpenShell (Null if another type) <br>
Standard_EXPORT   Handle_StepShape_OpenShell OpenShell() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
