// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StepToTopoDS_Root_HeaderFile
#define _StepToTopoDS_Root_HeaderFile

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! This class implements the common services for <br>
//!           all classes of StepToTopoDS which report error <br>
//!	    	  and sets and returns precision. <br>
class StepToTopoDS_Root  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

  Standard_Boolean IsDone() const;
//! Returns the value of "MyPrecision" <br>
  Standard_Real Precision() const;
//! Sets the value of "MyPrecision" <br>
  void SetPrecision(const Standard_Real preci) ;
//! Returns the value of "MaxTol" <br>
  Standard_Real MaxTol() const;
//! Sets the value of MaxTol <br>
  void SetMaxTol(const Standard_Real maxpreci) ;





protected:

 // Methods PROTECTED
 // 


Standard_EXPORT StepToTopoDS_Root();


 // Fields PROTECTED
 //
Standard_Boolean done;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Real myPrecision;
Standard_Real myMaxTol;


};


#include <StepToTopoDS_Root.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
