// File generated by CPPExt (Enum)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Storage_OpenMode_HeaderFile
#define _Storage_OpenMode_HeaderFile

//! Error codes returned by the ErrorStatus <br>
//! function on a Storage_Data set of data during a <br>
//! storage or retrieval operation : <br>
//! -   Storage_VSOk : no problem has been detected <br>
//! -   Storage_VSOpenError : an error has <br>
//!  occurred when opening the driver <br>
//! -   Storage_VSModeError : the driver has not <br>
//!  been opened in the correct mode <br>
//! -   Storage_VSCloseError : an error has <br>
//!   occurred when closing the driver <br>
//! -   Storage_VSAlreadyOpen : the driver is   already open <br>
//! -   Storage_VSNotOpen : the driver is not   open <br>
//! -   Storage_VSSectionNotFound : a section <br>
//!   has not been found in the driver <br>
//! -   Storage_VSWriteError : an error occurred when writing the driver <br>
//! -   Storage_VSFormatError : the file format is wrong <br>
//! -   Storage_VSUnknownType : a type is not known from the schema <br>
//! -   Storage_VSTypeMismatch : trying to read   a wrong type <br>
//! -   Storage_VSInternalError : an internal error  has been detected <br>
//! -   Storage_VSExtCharParityError : an error <br>
//!   has occurred while reading 16 bit characte <br>
enum Storage_OpenMode { 
 Storage_VSNone,
Storage_VSRead,
Storage_VSWrite,
Storage_VSReadWrite
};


#ifndef _Standard_PrimitiveTypes_HeaderFile
#include <Standard_PrimitiveTypes.hxx>
#endif

#endif
