// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TDF_CopyLabel_HeaderFile
#define _TDF_CopyLabel_HeaderFile

#ifndef _Handle_TDF_RelocationTable_HeaderFile
#include <Handle_TDF_RelocationTable.hxx>
#endif
#ifndef _TDF_Label_HeaderFile
#include <TDF_Label.hxx>
#endif
#ifndef _TDF_IDFilter_HeaderFile
#include <TDF_IDFilter.hxx>
#endif
#ifndef _TDF_AttributeMap_HeaderFile
#include <TDF_AttributeMap.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_TDF_DataSet_HeaderFile
#include <Handle_TDF_DataSet.hxx>
#endif
class TDF_RelocationTable;
class TDF_Label;
class TDF_IDFilter;
class TDF_AttributeMap;
class TDF_DataSet;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class TDF_CopyLabel  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Empty  constructor <br>
Standard_EXPORT TDF_CopyLabel();

//! CopyTool <br>
Standard_EXPORT TDF_CopyLabel(const TDF_Label& aSource,const TDF_Label& aTarget);

//! Loads  src  and  tgt  labels <br>
Standard_EXPORT   void Load(const TDF_Label& aSource,const TDF_Label& aTarget) ;

//!  Sets  filter <br>
Standard_EXPORT   void UseFilter(const TDF_IDFilter& aFilter) ;

//! Check  external  references and  if  exist  fills  the  aExternals  Map <br>
Standard_EXPORT static  Standard_Boolean ExternalReferences(const TDF_Label& Lab,TDF_AttributeMap& aExternals,const TDF_IDFilter& aFilter) ;

//! Check  external  references and  if  exist  fills  the  aExternals  Map <br>
Standard_EXPORT static  void ExternalReferences(const TDF_Label& aRefLab,const TDF_Label& Lab,TDF_AttributeMap& aExternals,const TDF_IDFilter& aFilter,Handle(TDF_DataSet)& aDataSet) ;

//!  performs  algorithm  of  selfcontained  copy <br>
Standard_EXPORT   void Perform() ;

  Standard_Boolean IsDone() const;

//! returns  relocation  table <br>
Standard_EXPORT  const Handle_TDF_RelocationTable& RelocationTable() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_TDF_RelocationTable myRT;
TDF_Label mySL;
TDF_Label myTL;
TDF_IDFilter myFilter;
TDF_AttributeMap myMapOfExt;
Standard_Boolean myIsDone;


};


#include <TDF_CopyLabel.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
