// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TDocStd_HeaderFile
#define _TDocStd_HeaderFile

class TDF_IDList;
class TDocStd_Application;
class TDocStd_Document;
class TDocStd_Context;
class TDocStd_XLink;
class TDocStd_XLinkIterator;
class TDocStd_XLinkTool;
class TDocStd_Owner;
class TDocStd_Modified;
class TDocStd_XLinkRoot;
class TDocStd_PathParser;
class TDocStd_CompoundDelta;
class TDocStd_LabelIDMapDataMap;
class TDocStd_ApplicationDelta;
class TDocStd_MultiTransactionManager;
class TDocStd_SequenceOfApplicationDelta;
class TDocStd_SequenceOfDocument;
class TDocStd_DataMapNodeOfLabelIDMapDataMap;
class TDocStd_DataMapIteratorOfLabelIDMapDataMap;
class TDocStd_SequenceNodeOfSequenceOfApplicationDelta;
class TDocStd_SequenceNodeOfSequenceOfDocument;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! This package define  CAF main classes. <br>
//! <br>
//!          * The standard application root class <br>
//! <br>
//!          * The standard document wich contains data <br>
//! <br>
//!          * The external reference mechanism between documents <br>
//! <br>
//!          * Attributes for Document management <br>
//! Standard documents offer you a ready-to-use <br>
//! document containing a TDF-based data <br>
//!  structure. The documents themselves are <br>
//!  contained in a class inheriting from <br>
//! TDocStd_Application which manages creation, <br>
//! storage and retrieval of documents. <br>
//! You can implement undo and redo in your <br>
//! document, and refer from the data framework of <br>
//! one document to that of another one. This is <br>
//! done by means of external link attributes, which <br>
//! store the path and the entry of external links. To <br>
//! sum up, standard documents alone provide <br>
//! access to the data framework. They also allow <br>
//! you to: <br>
//! -   Update external links <br>
//! -   Manage the saving and opening of data <br>
//! -   Manage undo/redo functionality. <br>
//! Note <br>
//! For information on the relations between this <br>
//! component of OCAF and the others, refer to the <br>
//! OCAF User's Guide. <br>
class TDocStd  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Appends to <anIDList> the list of the attributes <br>
//!          IDs of this package. CAUTION: <anIDList> is NOT <br>
//!          cleared before use. <br>
Standard_EXPORT static  void IDList(TDF_IDList& anIDList) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //

friend class TDocStd_Application;
friend class TDocStd_Document;
friend class TDocStd_Context;
friend class TDocStd_XLink;
friend class TDocStd_XLinkIterator;
friend class TDocStd_XLinkTool;
friend class TDocStd_Owner;
friend class TDocStd_Modified;
friend class TDocStd_XLinkRoot;
friend class TDocStd_PathParser;
friend class TDocStd_CompoundDelta;
friend class TDocStd_LabelIDMapDataMap;
friend class TDocStd_ApplicationDelta;
friend class TDocStd_MultiTransactionManager;
friend class TDocStd_SequenceOfApplicationDelta;
friend class TDocStd_SequenceOfDocument;
friend class TDocStd_DataMapNodeOfLabelIDMapDataMap;
friend class TDocStd_DataMapIteratorOfLabelIDMapDataMap;
friend class TDocStd_SequenceNodeOfSequenceOfApplicationDelta;
friend class TDocStd_SequenceNodeOfSequenceOfDocument;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
