// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Transfer_DispatchControl_HeaderFile
#define _Transfer_DispatchControl_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Transfer_DispatchControl_HeaderFile
#include <Handle_Transfer_DispatchControl.hxx>
#endif

#ifndef _Handle_Transfer_TransientProcess_HeaderFile
#include <Handle_Transfer_TransientProcess.hxx>
#endif
#ifndef _Handle_Interface_InterfaceModel_HeaderFile
#include <Handle_Interface_InterfaceModel.hxx>
#endif
#ifndef _Interface_CopyControl_HeaderFile
#include <Interface_CopyControl.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Transfer_TransientProcess;
class Interface_InterfaceModel;
class Interface_InterfaceError;
class Standard_Transient;


//! This is an auxiliary class for TransferDispatch, which allows <br>
//!           to record simple copies, as CopyControl from Interface, but <br>
//!           based on a TransientProcess. Hence, it allows in addition <br>
//!           more actions (such as recording results of adaptations) <br>
class Transfer_DispatchControl : public Interface_CopyControl {

public:
 // Methods PUBLIC
 // 

//! Creates the DispatchControl, ready for use <br>
Standard_EXPORT Transfer_DispatchControl(const Handle(Interface_InterfaceModel)& model,const Handle(Transfer_TransientProcess)& TP);

//! Returns the content of the DispatchControl : it can be used <br>
//!           for a direct call, if the basic methods do not suffice <br>
Standard_EXPORT  const Handle_Transfer_TransientProcess& TransientProcess() const;

//! Returns the Model from which the transfer is to be done <br>
Standard_EXPORT  const Handle_Interface_InterfaceModel& StartingModel() const;

//! Clears the List of Copied Results <br>
Standard_EXPORT   void Clear() ;

//! Binds a (Transient) Result to a (Transient) Starting Entity <br>
Standard_EXPORT   void Bind(const Handle(Standard_Transient)& ent,const Handle(Standard_Transient)& res) ;

//! Searches for the Result bound to a Starting Entity <br>
//!           If Found, returns True and fills <res> <br>
//!           Else, returns False and nullifies <res> <br>
Standard_EXPORT   Standard_Boolean Search(const Handle(Standard_Transient)& ent,Handle(Standard_Transient)& res) const;
//Standard_EXPORT ~Transfer_DispatchControl();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Transfer_TransientProcess theTP;
Handle_Interface_InterfaceModel themodel;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
