// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _V3d_PerspectiveView_HeaderFile
#define _V3d_PerspectiveView_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_V3d_PerspectiveView_HeaderFile
#include <Handle_V3d_PerspectiveView.hxx>
#endif

#ifndef _V3d_View_HeaderFile
#include <V3d_View.hxx>
#endif
#ifndef _Handle_V3d_Viewer_HeaderFile
#include <Handle_V3d_Viewer.hxx>
#endif
#ifndef _Handle_V3d_OrthographicView_HeaderFile
#include <Handle_V3d_OrthographicView.hxx>
#endif
#ifndef _Quantity_PlaneAngle_HeaderFile
#include <Quantity_PlaneAngle.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class Viewer_BadValue;
class V3d_Viewer;
class V3d_OrthographicView;


//! Creates and modifies a perspective <br>
//!           See the methods of the class View <br>
class V3d_PerspectiveView : public V3d_View {

public:
 // Methods PUBLIC
 // 

//! Defines a perspective view in a viewer VM. <br>
//!          The default angle of opening is given <br>
//!          by the viewer. <br>
Standard_EXPORT V3d_PerspectiveView(const Handle(V3d_Viewer)& VM);

//! Creates a perspective view from the parameters <br>
//!	    of an orthographic view. <br>
//!          The parameters of the original view are duplicated <br>
//!          in the resulting view (Projection,Mapping,Context) . <br>
//!          The view thus created must be activated in a new window. <br>
//!          The default angle of opening is given <br>
//!          by the viewer. <br>
Standard_EXPORT V3d_PerspectiveView(const Handle(V3d_Viewer)& VM,const Handle(V3d_OrthographicView)& V);

//! Creates one perspective view from another. <br>
//!          The parameters of the original view are duplicated <br>
//!          in the resulting view (Projection,Mapping,Context) . <br>
//!          The view thus created must be activated in a new window. <br>
Standard_EXPORT V3d_PerspectiveView(const Handle(V3d_Viewer)& VM,const Handle(V3d_PerspectiveView)& V);


Standard_EXPORT   Handle_V3d_PerspectiveView Copy() const;

//! Modifies the angle of opening of the perspective in RADIANS. <br>
//!	    The projection window is resized according to the <br>
//!	    formula : <br>
//!	    TAN(Angle/2) = Size/Length <br>
//!	    	Size expresses the smallest dimension of the window. <br>
//!	        Length expresses the focal length. <br>//!  Warning! raises BadValue from Viewer <br>
//!	    if the opening angle is <= 0 or >= PI <br>
Standard_EXPORT   void SetAngle(const Quantity_PlaneAngle Angle) ;

//! Returns the value of the angle of opening. <br>
Standard_EXPORT   Quantity_PlaneAngle Angle() const;

//! Modifies the viewing perspective volume by given <br>
//!		angle of opening of the perspective in RADIANS, <br>
//!      aspect ratio of window width to its height and <br>
//!      near and far clipping planes <br>
Standard_EXPORT   void SetPerspective(const Quantity_PlaneAngle Angle,const Standard_Real UVRatio,const Standard_Real ZNear,const Standard_Real ZFar) ;
//Standard_EXPORT ~V3d_PerspectiveView();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
