// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Vrml_Instancing_HeaderFile
#define _Vrml_Instancing_HeaderFile

#ifndef _TCollection_AsciiString_HeaderFile
#include <TCollection_AsciiString.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class TCollection_AsciiString;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! defines  "instancing" - using  the  same  instance  of  a  node <br>
//!          multiple  times. <br>
//!  It  is  accomplished  by  using  the  "DEF"  and  "USE"  keywords. <br>
//!  The  DEF  keyword  both  defines  a  named  node,  and  creates  a  single <br>
//!  instance  of  it. <br>
//!  The  USE  keyword  indicates  that  the  most  recently  defined  instance <br>
//!  should  be  used  again. <br>
//!  If  several  nades  were  given  the  same  name,  then  the  last  DEF <br>
//!  encountered  during  parsing  "wins". <br>
//!  DEF/USE  is  limited  to  a  single  file. <br>
class Vrml_Instancing  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Adds "DEF  <myName>" in  anOStream  (VRML  file). <br>
Standard_EXPORT Vrml_Instancing(const TCollection_AsciiString& aString);

//! Adds "USE  <myName>" in  anOStream (VRML  file). <br>
Standard_EXPORT   Standard_OStream& DEF(Standard_OStream& anOStream) const;


Standard_EXPORT   Standard_OStream& USE(Standard_OStream& anOStream) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TCollection_AsciiString myName;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
