// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Vrml_Material_HeaderFile
#define _Vrml_Material_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Vrml_Material_HeaderFile
#include <Handle_Vrml_Material.hxx>
#endif

#ifndef _Handle_Quantity_HArray1OfColor_HeaderFile
#include <Handle_Quantity_HArray1OfColor.hxx>
#endif
#ifndef _Handle_TColStd_HArray1OfReal_HeaderFile
#include <Handle_TColStd_HArray1OfReal.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class Quantity_HArray1OfColor;
class TColStd_HArray1OfReal;


//! defines a Material node of VRML specifying properties of geometry <br>
//!          and its appearance. <br>
//!  This node defines the current surface material properties for all subsequent shapes. <br>
//!  Material sets several components of the current material during traversal. Different shapes <br>
//!  interpret materials with multiple values differently. To bind materials to shapes, use a <br>
//!  MaterialBinding node. <br>
class Vrml_Material : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT Vrml_Material(const Handle(Quantity_HArray1OfColor)& aAmbientColor,const Handle(Quantity_HArray1OfColor)& aDiffuseColor,const Handle(Quantity_HArray1OfColor)& aSpecularColor,const Handle(Quantity_HArray1OfColor)& aEmissiveColor,const Handle(TColStd_HArray1OfReal)& aShininess,const Handle(TColStd_HArray1OfReal)& aTransparency);


Standard_EXPORT Vrml_Material();


Standard_EXPORT   void SetAmbientColor(const Handle(Quantity_HArray1OfColor)& aAmbientColor) ;


Standard_EXPORT   Handle_Quantity_HArray1OfColor AmbientColor() const;


Standard_EXPORT   void SetDiffuseColor(const Handle(Quantity_HArray1OfColor)& aDiffuseColor) ;


Standard_EXPORT   Handle_Quantity_HArray1OfColor DiffuseColor() const;


Standard_EXPORT   void SetSpecularColor(const Handle(Quantity_HArray1OfColor)& aSpecularColor) ;


Standard_EXPORT   Handle_Quantity_HArray1OfColor SpecularColor() const;


Standard_EXPORT   void SetEmissiveColor(const Handle(Quantity_HArray1OfColor)& aEmissiveColor) ;


Standard_EXPORT   Handle_Quantity_HArray1OfColor EmissiveColor() const;


Standard_EXPORT   void SetShininess(const Handle(TColStd_HArray1OfReal)& aShininess) ;


Standard_EXPORT   Handle_TColStd_HArray1OfReal Shininess() const;


Standard_EXPORT   void SetTransparency(const Handle(TColStd_HArray1OfReal)& aTransparency) ;


Standard_EXPORT   Handle_TColStd_HArray1OfReal Transparency() const;


Standard_EXPORT   Standard_OStream& Print(Standard_OStream& anOStream) const;
//Standard_EXPORT ~Vrml_Material();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Quantity_HArray1OfColor myAmbientColor;
Handle_Quantity_HArray1OfColor myDiffuseColor;
Handle_Quantity_HArray1OfColor mySpecularColor;
Handle_Quantity_HArray1OfColor myEmissiveColor;
Handle_TColStd_HArray1OfReal myShininess;
Handle_TColStd_HArray1OfReal myTransparency;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
