// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Vrml_Normal_HeaderFile
#define _Vrml_Normal_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Vrml_Normal_HeaderFile
#include <Handle_Vrml_Normal.hxx>
#endif

#ifndef _Handle_TColgp_HArray1OfVec_HeaderFile
#include <Handle_TColgp_HArray1OfVec.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class TColgp_HArray1OfVec;


//! defines a Normal node of VRML specifying properties of geometry <br>
//!          and its appearance. <br>
//!  This node defines a set of 3D surface normal vectors to be used by vertex-based shape <br>
//!  nodes (IndexedFaceSet, IndexedLineSet, PointSet) that follow it in the scene graph. This <br>
//!  node does not produce a visible result during rendering; it simply replaces the current <br>
//!  normals in the rendering state for subsequent nodes to use. This node contains one <br>
//!  multiple-valued field that contains the normal vectors. <br>
class Vrml_Normal : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT Vrml_Normal(const Handle(TColgp_HArray1OfVec)& aVector);


Standard_EXPORT Vrml_Normal();


Standard_EXPORT   void SetVector(const Handle(TColgp_HArray1OfVec)& aVector) ;


Standard_EXPORT   Handle_TColgp_HArray1OfVec Vector() const;


Standard_EXPORT   Standard_OStream& Print(Standard_OStream& anOStream) const;
//Standard_EXPORT ~Vrml_Normal();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_TColgp_HArray1OfVec myVector;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
