// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Vrml_Texture2_HeaderFile
#define _Vrml_Texture2_HeaderFile

#ifndef _TCollection_AsciiString_HeaderFile
#include <TCollection_AsciiString.hxx>
#endif
#ifndef _Handle_Vrml_SFImage_HeaderFile
#include <Handle_Vrml_SFImage.hxx>
#endif
#ifndef _Vrml_Texture2Wrap_HeaderFile
#include <Vrml_Texture2Wrap.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class Vrml_SFImage;
class TCollection_AsciiString;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! defines a Texture2 node of VRML specifying properties of geometry <br>
//!          and its appearance. <br>
//!  This  property  node  defines  a  texture  map  and  parameters  for  that  map <br>
//!  The  texture  can  be  read  from  the  URL  specified  by  the  filename  field. <br>
//!  To  turn  off  texturing,  set  the  filename  field  to  an  empty  string  (""). <br>
//!  Textures  can  alsobe  specified  inline  by  setting  the  image  field <br>
//!  to  contain  the  texture  data. <br>
//!  By  default  : <br>
//!    myFilename ("") <br>
//!    myImage (0 0 0) <br>
//!    myWrapS (Vrml_REPEAT) <br>
//!    myWrapT (Vrml_REPEAT) <br>
class Vrml_Texture2  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT Vrml_Texture2();


Standard_EXPORT Vrml_Texture2(const TCollection_AsciiString& aFilename,const Handle(Vrml_SFImage)& aImage,const Vrml_Texture2Wrap aWrapS,const Vrml_Texture2Wrap aWrapT);


Standard_EXPORT   void SetFilename(const TCollection_AsciiString& aFilename) ;


Standard_EXPORT   TCollection_AsciiString Filename() const;


Standard_EXPORT   void SetImage(const Handle(Vrml_SFImage)& aImage) ;


Standard_EXPORT   Handle_Vrml_SFImage Image() const;


Standard_EXPORT   void SetWrapS(const Vrml_Texture2Wrap aWrapS) ;


Standard_EXPORT   Vrml_Texture2Wrap WrapS() const;


Standard_EXPORT   void SetWrapT(const Vrml_Texture2Wrap aWrapT) ;


Standard_EXPORT   Vrml_Texture2Wrap WrapT() const;


Standard_EXPORT   Standard_OStream& Print(Standard_OStream& anOStream) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TCollection_AsciiString myFilename;
Handle_Vrml_SFImage myImage;
Vrml_Texture2Wrap myWrapS;
Vrml_Texture2Wrap myWrapT;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
