// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _WOKBuilder_Command_HeaderFile
#define _WOKBuilder_Command_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_WOKBuilder_Command_HeaderFile
#include <Handle_WOKBuilder_Command.hxx>
#endif

#ifndef _WOKBuilder_ToolInShell_HeaderFile
#include <WOKBuilder_ToolInShell.hxx>
#endif
#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _WOKBuilder_BuildStatus_HeaderFile
#include <WOKBuilder_BuildStatus.hxx>
#endif
#ifndef _Handle_WOKUtils_Path_HeaderFile
#include <Handle_WOKUtils_Path.hxx>
#endif
class Standard_ProgramError;
class TCollection_HAsciiString;
class WOKUtils_Param;
class WOKUtils_Path;



class WOKBuilder_Command : public WOKBuilder_ToolInShell {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT WOKBuilder_Command(const Handle(TCollection_HAsciiString)& aname,const WOKUtils_Param& params);


Standard_EXPORT virtual  void Load() ;

//! copies afrom in ato <br>
Standard_EXPORT   WOKBuilder_BuildStatus Copy(const Handle(WOKUtils_Path)& afrom,const Handle(WOKUtils_Path)& ato) ;

//! copies afrom in ato <br>
Standard_EXPORT   WOKBuilder_BuildStatus PreserveCopy(const Handle(WOKUtils_Path)& afrom,const Handle(WOKUtils_Path)& ato) ;

//! copies afrom in ato and chmod <br>
Standard_EXPORT   WOKBuilder_BuildStatus CopyAndChmod(const Handle(WOKUtils_Path)& afrom,const Handle(WOKUtils_Path)& ato) ;

//! Moves afrom in ato <br>
Standard_EXPORT   WOKBuilder_BuildStatus Move(const Handle(WOKUtils_Path)& afrom,const Handle(WOKUtils_Path)& ato) ;

//! Replaces <ato> with <afrom> if <afrom> differs from <ato> <br>
//!          NB : Destroys afrom in all cases <br>
Standard_EXPORT   WOKBuilder_BuildStatus ReplaceIfChanged(const Handle(WOKUtils_Path)& afrom,const Handle(WOKUtils_Path)& ato) ;

//! Replaces <ato> with <afrom> if <afrom> differs from <abase> <br>
//!          NB : - Destroys afrom in all cases <br>
//!               - Status is Success if replacement was done <br>
//!                           Unbuilt if replacement was not done <br>
//!                           Failed if errors occured <br>
Standard_EXPORT   WOKBuilder_BuildStatus ReplaceIfChangedWith(const Handle(WOKUtils_Path)& afrom,const Handle(WOKUtils_Path)& abase,const Handle(WOKUtils_Path)& ato) ;


Standard_EXPORT   WOKBuilder_BuildStatus Compress(const Handle(WOKUtils_Path)& afile) ;


Standard_EXPORT   WOKBuilder_BuildStatus CompressTo(const Handle(WOKUtils_Path)& afile,const Handle(WOKUtils_Path)& adest) ;


Standard_EXPORT   WOKBuilder_BuildStatus UnCompress(const Handle(WOKUtils_Path)& afile) ;


Standard_EXPORT   WOKBuilder_BuildStatus UnCompressTo(const Handle(WOKUtils_Path)& afile,const Handle(WOKUtils_Path)& adest) ;


Standard_EXPORT   WOKBuilder_BuildStatus Execute() ;
//Standard_EXPORT ~WOKBuilder_Command();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
