// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _WOKMake_MetaStep_HeaderFile
#define _WOKMake_MetaStep_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_WOKMake_MetaStep_HeaderFile
#include <Handle_WOKMake_MetaStep.hxx>
#endif

#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _Handle_TColStd_HSequenceOfHAsciiString_HeaderFile
#include <Handle_TColStd_HSequenceOfHAsciiString.hxx>
#endif
#ifndef _WOKMake_Step_HeaderFile
#include <WOKMake_Step.hxx>
#endif
#ifndef _Handle_WOKMake_BuildProcess_HeaderFile
#include <Handle_WOKMake_BuildProcess.hxx>
#endif
#ifndef _Handle_WOKernel_DevUnit_HeaderFile
#include <Handle_WOKernel_DevUnit.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_WOKMake_InputFile_HeaderFile
#include <Handle_WOKMake_InputFile.hxx>
#endif
#ifndef _Handle_WOKMake_HSequenceOfInputFile_HeaderFile
#include <Handle_WOKMake_HSequenceOfInputFile.hxx>
#endif
#ifndef _WOKMake_Status_HeaderFile
#include <WOKMake_Status.hxx>
#endif
#ifndef _Handle_WOKMake_OutputFile_HeaderFile
#include <Handle_WOKMake_OutputFile.hxx>
#endif
class TCollection_HAsciiString;
class TColStd_HSequenceOfHAsciiString;
class WOKMake_BuildProcess;
class WOKernel_DevUnit;
class WOKMake_InputFile;
class WOKMake_HSequenceOfInputFile;
class WOKMake_OutputFile;



class WOKMake_MetaStep : public WOKMake_Step {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT WOKMake_MetaStep(const Handle(WOKMake_BuildProcess)& aprocess,const Handle(WOKernel_DevUnit)& aunit,const Handle(TCollection_HAsciiString)& acode,const Standard_Boolean checked,const Standard_Boolean hidden);


Standard_EXPORT   void SetAdmFileType(const Handle(TCollection_HAsciiString)& atype) ;


Standard_EXPORT   void SetOutputDirTypeName(const Handle(TCollection_HAsciiString)& atype) ;


Standard_EXPORT virtual  Handle_TColStd_HSequenceOfHAsciiString UnderlyingSteps() ;


Standard_EXPORT   void SetUnderlyingSteps(const Handle(TColStd_HSequenceOfHAsciiString)& steps) ;


Standard_EXPORT   Handle_TColStd_HSequenceOfHAsciiString Parts() const;


Standard_EXPORT   void SetParts(const Handle(TColStd_HSequenceOfHAsciiString)& parts) ;

//! Computes dependances <br>
//!          Decides if perform is needed. <br>
//!          Performs Step on needed entities <br>
//!          returns status <br>
Standard_EXPORT virtual  WOKMake_Status Make() ;
//Standard_EXPORT ~WOKMake_MetaStep();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


Standard_EXPORT virtual  Standard_Boolean HandleInputFile(const Handle(WOKMake_InputFile)& anitem) ;


Standard_EXPORT virtual  Handle_TCollection_HAsciiString AdmFileType() const;


Standard_EXPORT virtual  Handle_TCollection_HAsciiString OutputDirTypeName() const;

//! Get Underlying steps using output of input steps <br>
Standard_EXPORT virtual  Handle_TColStd_HSequenceOfHAsciiString GetUnderlyingSteps() ;

//! Get Underlying steps using last output of step <br>
Standard_EXPORT virtual  Handle_TColStd_HSequenceOfHAsciiString GetLastUnderlyingSteps() ;

//! Handles Output file new/same/disappereread <br>
Standard_EXPORT virtual  Standard_Boolean HandleOutputFile(const Handle(WOKMake_OutputFile)& anfile) ;


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

//! Executes underlying steps <br>
//!          Computes output files <br>
Standard_EXPORT virtual  void Execute(const Handle(WOKMake_HSequenceOfInputFile)& execlist) ;


 // Fields PRIVATE
 //
Handle_TCollection_HAsciiString myadmtype;
Handle_TCollection_HAsciiString myouttype;
Handle_TColStd_HSequenceOfHAsciiString myparts;
Handle_TColStd_HSequenceOfHAsciiString myundersteps;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
