// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _WOKernel_Factory_HeaderFile
#define _WOKernel_Factory_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_WOKernel_Factory_HeaderFile
#include <Handle_WOKernel_Factory.hxx>
#endif

#ifndef _Handle_TColStd_HSequenceOfHAsciiString_HeaderFile
#include <Handle_TColStd_HSequenceOfHAsciiString.hxx>
#endif
#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _Handle_WOKUtils_Path_HeaderFile
#include <Handle_WOKUtils_Path.hxx>
#endif
#ifndef _WOKernel_Entity_HeaderFile
#include <WOKernel_Entity.hxx>
#endif
#ifndef _Handle_WOKernel_Session_HeaderFile
#include <Handle_WOKernel_Session.hxx>
#endif
#ifndef _Handle_WOKernel_Workshop_HeaderFile
#include <Handle_WOKernel_Workshop.hxx>
#endif
#ifndef _Handle_WOKernel_Warehouse_HeaderFile
#include <Handle_WOKernel_Warehouse.hxx>
#endif
class TColStd_HSequenceOfHAsciiString;
class TCollection_HAsciiString;
class WOKUtils_Path;
class Standard_ProgramError;
class WOKernel_Session;
class WOKernel_Workshop;
class WOKernel_Warehouse;


//! WOK Factory : corresponds to a developpers Team <br>
class WOKernel_Factory : public WOKernel_Entity {

public:
 // Methods PUBLIC
 // 

//! instantiates a factory <br>
Standard_EXPORT WOKernel_Factory(const Handle(TCollection_HAsciiString)& aname,const Handle(WOKernel_Session)& anesting);


Standard_EXPORT virtual  Handle_TCollection_HAsciiString EntityCode() const;


Standard_EXPORT   void ReadWSLIST() ;


Standard_EXPORT   void WriteWSList() ;

//! opens a factory <br>
//!          loads Workshop list <br>
//!          load Warehouse parameters <br>
Standard_EXPORT virtual  void Open() ;

//! closes Factory <br>
Standard_EXPORT virtual  void Close() ;

//! gives the sequence of workshop in factory <br>
Standard_EXPORT   Handle_TColStd_HSequenceOfHAsciiString Workshops() const;

//! updates files WSLIST with myworkshops <br>
Standard_EXPORT   void DumpWorkshopList() const;

//! Adds workshop to factory <br>
//!          Updates WSLIST <br>
Standard_EXPORT   void AddWorkshop(const Handle(WOKernel_Workshop)& aworkshop) ;

//! removes workshop <br>
Standard_EXPORT   void RemoveWorkshop(const Handle(WOKernel_Workshop)& aworkshop) ;


Standard_EXPORT   void SetWarehouse(const Handle(WOKernel_Warehouse)& awarehouse) ;

//! gives the warehouse of factory <br>
Standard_EXPORT   Handle_TCollection_HAsciiString Warehouse() const;


Standard_EXPORT   void SetSourceStorage(const Handle(WOKUtils_Path)& astorage) ;

//! gives the SCCS repository of factory <br>
Standard_EXPORT   Handle_WOKUtils_Path SourceStorage() const;
//Standard_EXPORT ~WOKernel_Factory();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_TColStd_HSequenceOfHAsciiString myworkshops;
Handle_TCollection_HAsciiString mywarehouse;
Handle_WOKUtils_Path mysccsbase;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
