// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _WOKernel_FileType_HeaderFile
#define _WOKernel_FileType_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_WOKernel_FileType_HeaderFile
#include <Handle_WOKernel_FileType.hxx>
#endif

#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _EDL_Template_HeaderFile
#include <EDL_Template.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Handle_TColStd_HSequenceOfHAsciiString_HeaderFile
#include <Handle_TColStd_HSequenceOfHAsciiString.hxx>
#endif
class TCollection_HAsciiString;
class Standard_ProgramError;
class EDL_Template;
class WOKUtils_Param;
class TColStd_HSequenceOfHAsciiString;


//! manages the various file types in WOK <br>
class WOKernel_FileType : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT WOKernel_FileType();


Standard_EXPORT WOKernel_FileType(const Handle(TCollection_HAsciiString)& aname,const EDL_Template& atemplate);

 const Handle_TCollection_HAsciiString& Name() const;

 const EDL_Template& Template() const;

//! Computes a path using a format and parameters <br>
//!          Supposes that WOKernel_FileTypeBase::SetNeededArguments <br>
//!          was called Before use. <br>
Standard_EXPORT   Handle_TCollection_HAsciiString ComputePath(const WOKUtils_Param& params,const Handle(TCollection_HAsciiString)& afilename) ;


Standard_EXPORT   Handle_TCollection_HAsciiString GetDefinition() const;


Standard_EXPORT   Handle_TColStd_HSequenceOfHAsciiString GetArguments() const;


Standard_EXPORT   void SetStationDependent() ;


Standard_EXPORT   void UnSetStationDependent() ;

  Standard_Boolean IsStationDependent() const;


Standard_EXPORT   void SetDBMSDependent() ;


Standard_EXPORT   void UnSetDBMSDependent() ;

  Standard_Boolean IsDBMSDependent() const;


Standard_EXPORT   void SetNestingDependent() ;


Standard_EXPORT   void UnSetNestingDependent() ;

  Standard_Boolean IsNestingDependent() const;


Standard_EXPORT   void SetEntityDependent() ;


Standard_EXPORT   void UnSetEntityDependent() ;

  Standard_Boolean IsEntityDependent() const;


Standard_EXPORT   void SetFileDependent() ;


Standard_EXPORT   void UnSetFileDependent() ;

  Standard_Boolean IsFileDependent() const;


Standard_EXPORT   void Directory() ;


Standard_EXPORT   void File() ;

  Standard_Boolean IsFile() const;

  Standard_Boolean IsDirectory() const;


Standard_EXPORT   Handle_TCollection_HAsciiString GetDirectory(const WOKUtils_Param& params) ;


Standard_EXPORT   Handle_TCollection_HAsciiString GetFile(const WOKUtils_Param& params) ;
//Standard_EXPORT ~WOKernel_FileType();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

//! calculates Station and DBMS dependency for Type <br>
Standard_EXPORT   void GetDependency() ;


 // Fields PRIVATE
 //
Handle_TCollection_HAsciiString myname;
EDL_Template mytemplate;
Standard_Boolean mystationdep;
Standard_Boolean mydbmsdep;
Standard_Boolean mynestingdep;
Standard_Boolean myentitydep;
Standard_Boolean myfiledep;
Standard_Boolean myisrep;


};


#include <WOKernel_FileType.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
