// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Xw_HeaderFile
#define _Xw_HeaderFile

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class Xw_Driver;
class Xw_Window;
class Xw_PixMap;
class Xw_ColorMap;
class Xw_TypeMap;
class Xw_WidthMap;
class Xw_FontMap;
class Xw_MarkMap;
class Xw_GraphicDevice;
class Xw_IconBox;
class Xw_TextManager;
class Xw_ListOfIndexs;
class Xw_HListOfIndexs;
class Xw_ListOfMFTFonts;
class Xw_HListOfMFTFonts;
class Xw_ListOfMFTSizes;
class Xw_HListOfMFTSizes;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! This package contains the common X graphic interface. <br>
//!  Warning: All the interface is described by a set of C routines. <br>
//!          All these C routines are stored in the library <br>
//!          of this package. <br>
class Xw  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Global Trace Level for Maintenance Only <br>
Standard_EXPORT static  void SetTrace(const Standard_Integer TraceLevel,const Standard_Integer ErrorLevel) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

//! Return current global Trace level . <br>
Standard_EXPORT static  Standard_Integer TraceLevel() ;

//! Return current global Error level . <br>
Standard_EXPORT static  Standard_Integer ErrorLevel() ;


 // Fields PRIVATE
 //

friend class Xw_Driver;
friend class Xw_Window;
friend class Xw_PixMap;
friend class Xw_ColorMap;
friend class Xw_TypeMap;
friend class Xw_WidthMap;
friend class Xw_FontMap;
friend class Xw_MarkMap;
friend class Xw_GraphicDevice;
friend class Xw_IconBox;
friend class Xw_TextManager;
friend class Xw_ListOfIndexs;
friend class Xw_HListOfIndexs;
friend class Xw_ListOfMFTFonts;
friend class Xw_HListOfMFTFonts;
friend class Xw_ListOfMFTSizes;
friend class Xw_HListOfMFTSizes;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
