// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Xw_PixMap_HeaderFile
#define _Xw_PixMap_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Xw_PixMap_HeaderFile
#include <Handle_Xw_PixMap.hxx>
#endif

#ifndef _Aspect_Handle_HeaderFile
#include <Aspect_Handle.hxx>
#endif
#ifndef _Handle_Xw_Window_HeaderFile
#include <Handle_Xw_Window.hxx>
#endif
#ifndef _Aspect_PixMap_HeaderFile
#include <Aspect_PixMap.hxx>
#endif
#ifndef _Handle_Aspect_Window_HeaderFile
#include <Handle_Aspect_Window.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class Xw_Window;
class Aspect_PixmapDefinitionError;
class Aspect_PixmapError;
class Aspect_Window;


//! This class defines a X11 pixmap <br>
class Xw_PixMap : public Aspect_PixMap {

public:
 // Methods PUBLIC
 // 

//!  Warning! When <aDepth> is NULL , the pixmap is created <br>
//! with the SAME depth than the window <aWindow> <br>
Standard_EXPORT Xw_PixMap(const Handle(Aspect_Window)& aWindow,const Standard_Integer aWidth,const Standard_Integer anHeight,const Standard_Integer aDepth = 0);

//! Destroies the Pixmap <br>
//!  Trigger: Raises if Pixmap is not defined properly <br>
Standard_EXPORT virtual  void Destroy() ;

//! Dumps the Pixmap to an XWD,GIF or BMP file with <br>
//! an optional gamma correction value according to the graphic system <br>
Standard_EXPORT virtual  Standard_Boolean Dump(const Standard_CString aFilename,const Standard_Real aGammaValue = 1.0) const;

//! Returns the ID of the just created pixmap <br>
Standard_EXPORT virtual  Aspect_Handle PixmapID() const;
//Standard_EXPORT ~Xw_PixMap();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //
Aspect_Handle myPixmap;


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT   Standard_Integer PreferedDepth(const Handle(Aspect_Window)& aWindow,const Standard_Integer aDepth) const;


 // Fields PRIVATE
 //
Handle_Xw_Window myWindow;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
