// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _gce_MakeMirror_HeaderFile
#define _gce_MakeMirror_HeaderFile

#ifndef _gp_Trsf_HeaderFile
#include <gp_Trsf.hxx>
#endif
class gp_Pnt;
class gp_Ax1;
class gp_Lin;
class gp_Dir;
class gp_Pln;
class gp_Ax2;
class gp_Trsf;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! This class mplements elementary construction algorithms for a <br>
//! symmetrical transformation in 3D space about a point, <br>
//! axis or plane. The result is a gp_Trsf transformation. <br>
//! A MakeMirror object provides a framework for: <br>
//! -   defining the construction of the transformation, <br>
//! -   implementing the construction algorithm, and <br>
//! -   consulting the result. <br>
class gce_MakeMirror  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT gce_MakeMirror(const gp_Pnt& Point);


Standard_EXPORT gce_MakeMirror(const gp_Ax1& Axis);


Standard_EXPORT gce_MakeMirror(const gp_Lin& Line);

//! Makes a symmetry transformation af axis defined by <br>
//!          <Point> and <Direc>. <br>
Standard_EXPORT gce_MakeMirror(const gp_Pnt& Point,const gp_Dir& Direc);

//! Makes a symmetry transformation of plane <Plane>. <br>
Standard_EXPORT gce_MakeMirror(const gp_Pln& Plane);

//! Makes a symmetry transformation of plane <Plane>. <br>
Standard_EXPORT gce_MakeMirror(const gp_Ax2& Plane);

//! Returns the constructed transformation. <br>
Standard_EXPORT  const gp_Trsf& Value() const;


Standard_EXPORT  const gp_Trsf& Operator() const;
Standard_EXPORT operator gp_Trsf() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
gp_Trsf TheMirror;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
